package FI2.Arnold;
/**{p}
 * -- FI2.Arnold --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi tratti dal libro di Arnold-Gosling
 */

/**{f}
 * Vehicle.java
 * Arnold-Gosling esercizio 2.8 -
 * Vehicle: nella realizzazione viene gia' utilizzato il
 * controllo di visibilita' dei campi, definiti come privati
 *
 * @version 1.01 97/10/22
 * @author M.Moro DEI UPD
 */

/**{c}
 * Un veicolo -
 * solo a fini dimostrativi, il valore speciale 0 per
 * l'identificativo di classe comporta in qualche caso
 * un output disgnostico
 */
public class Vehicle
{
    private static long vId;
        // identificativo classe veicolo

    private long id;        // identificativo veicolo
    private float vel;      // velocita' corrente
    private int dir;        // direzione (in gradi)
    private String owner;   // proprietario

    /**[m][s]
     * Imposta l'identificativo di classe 
     * @param id  identificativo
     */
    public static void setvId(long id)
    {
        vId = id;
    } //[m] setvId

    /**[c]
     * Costruttore di default 
     */
    public Vehicle()
    {
        if (vId == 0)
            // diagnostica
            System.out.println("Vehicle()");
        /* id = vel = dir = 0; */
        owner = "<nowoner>";
    } //[c] Vehicle

    /**[c]
     * Costruttore con possessore
     * @param owner  possessore
     */
    public Vehicle(String owner)
    {
        if (vId == 0)
            // diagnostica
            System.out.println("Vehicle(" + owner + ")");
        /* id = vel = dir = 0; */
        this.owner = owner;
    } //[c] Vehicle

    /**[c]
     * Costruttore con identificativo e possessore
     * @param id  identificativo
     * @param owner  possessore
     */
    public Vehicle(long id, String owner)
    {
        if (vId == 0)
            // diagnostica
            System.out.println("Vehicle(" + id + ", " +
              owner + ")");
        /* vel = dir = 0; */
        this.id = id;
        this.owner = owner;
    } //[c] Vehicle

    /**[m]
     * Legge la velocita`
     * @return  la velocita` corrente
     */
    public float getSpeed()
    {
        return vel;
    } //[m] getSpeed

    /**[m]
     * Imposta la velocita`
     * @param vel  la velocita` corrente
     */
    public void setSpeed(float vel)
    {
        this.vel = vel;
    } //[m] setSpeed

    /**[m]
     * Legge la direzione
     * (-180 <= this.dir <= 180)
     * @return  la direzione corrente
     */
    public int getDir()
    {
        return dir;
    } //[m] getDir

    /**[m]
     * Imposta la direzione
     * (-180 <= this.dir <= 180)
     * @param dir  la direzione corrente
     */
    public void setDir(int dir)
    {
        dir %= 360;
        dir += 360;
        // ora 0 <= dir <= 720
        this.dir = (dir+180) % 360 - 180;
    } //[m] setDir

    /**[m]
     * Conversione a stringa -
     * fornisce il contenuto dei campi
     * @return la stringa
     */
    public String toString()
    {
        String str =
          "vId=" + vId +
          ", id=" + id +
          ", vel=" + vel +
          ", dir=" + dir +
          ", owner=" + owner;

        return str;
    } //[m] toString

    /**[m][s]
     * metodo di collaudo
     * @param args[]  non usato
     */
    static public void main(String[] args)
    {
        Vehicle boh = new Vehicle();
        Vehicle mine = new Vehicle("Sergio Rossi");
        Vehicle mineId = new Vehicle(34, "Mario Bianchi");

        System.out.println("boh: " + boh);
        System.out.println("mine: " + mine);
        System.out.println("mineId: " + mineId);

        mineId.setSpeed(3.5f);
        mineId.setDir(-390);
        System.out.println("Dopo mineId: vel=" +
          mineId.getSpeed() + " dir=" + mineId.getDir());
    } //[m][s] main

} //{c} Vehicle
