package FI2.Arnold;
/**{p}
 * -- FI2.Arnold --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi tratti dal libro di Arnold-Gosling
 */

/**{f}
 * Vehicle3.java
 * Arnold-Gosling esercizio 3.7 -
 * Vehicle3: estensione di Vehicle2 (vedi es3_01.java)
 * con un riferimento astratto EnergySource -
 * comprende esercizio 3.5
 * include equals e hashCode
 *
 * @version 1.01 97/10/22
 * @author M.Moro DEI UPD
 */

/**{c}
 * Un veicolo con fonte di energia
 * @see Vehicle2
 */
public class Vehicle3 extends Vehicle2
{
    private EnergySource en;    // serbatoio energia

    /**[c]
     * Costruttore completo: associa la fonte di energia
     * @param id  identificativo
     * @param owner  possessore
     * @param en  fonte di energia
     */
    public Vehicle3(long id, String owner, EnergySource en)
    {
        if (vId == 0)
            // diagnostica
            System.out.println("Vehicle3(" + id + ", " +
              owner + ", " + en + ")");
        /* vel = dir = 0; en=null; */
        this.id = id;
        this.owner = owner;
        this.en = en;
    } //[c] Vehicle3

    /**[m]
     * Conversione a stringa -
     * fornisce il contenuto dei campi
     * @return  la stringa
     */
    public String toString()
    {
        String str =
          super.toString() + ", {Vehicle3} energy=" + en;

        return str;
    } //[m] toString

    /**[m]
     * Confronta i valori di due oggetti Vehicle3
     * @param sndV  secondo Vehicle3 di confronto
     * @return  true se valori corrispondenti eguali
     */
    public boolean equals(Object sndV)
    {
        return
          (vId == ((Vehicle3)sndV).vId) &&
          (id == ((Vehicle3)sndV).id) &&
          (vel == ((Vehicle3)sndV).vel) &&
          (dir == ((Vehicle3)sndV).dir) &&
          owner.equals(((Vehicle3)sndV).owner)
          ;
          // en ignorato per semplicita'
          // il cast a Vehicle3 e` obbligatorio per rendere
          // i due oggetti di confronto omologhi
    } //[m] equals

    /**[m]
     * Calcola un hashcode basato su Id che e` univoco
     * @return  hashcode
     */
    public int hashcode()
    {
        return (int) (getId() % 30000);
    } //[m] hashcode

    /**[m]
     * Valuta la possibilita` di movimento
     * @return  true se ha serbatoio, false altrimenti e
     *          il serbatoio viene riempito
     */
    public boolean start()
    {
        if (en == null)
            return false;
        // vengono chiamati metodi in base all'oggetto
        if (en.empty())
        {
            en.full();
            return false;
        }
        return true;
    } //[m] start

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  un proprietario
     */
    static public void main(String[] args)
    {
        GasTank gt = new GasTank(3000);
        Battery bt = new Battery(24.0f);
        Vehicle3 boh1 = new Vehicle3(23,
          args.length!=0 ? args[0] : "", gt);
        Vehicle3 boh2 = new Vehicle3(23, "Sergio Rossi", bt);

        System.out.println("boh1: " + boh1);
        System.out.println("boh2: " + boh2);
        System.out.println("boh1 equals boh2 " +
          boh1.equals(boh2));
        System.out.println("hash boh1: " + boh1.hashcode());
        System.out.println("start boh1: " + boh1.start());
        bt.set(2.0f);
        System.out.println("batteria: " + bt);
        System.out.println("start boh2: " + boh2.start());
        System.out.println("batteria: " + bt);
    } //[m][s] main

} //{c} Vehicle3

