package FI2.Dictionary;
/**{p}
 * -- FI2.Dictionary --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Dizionari
 */

/**{f}
 * InspectableDictionary.java
 * interfaccia dizionario read-only -
 * derivata da Dictionary della v 1.x 
 *
 * @version 2.00 00/09/24
 * @author M.Moro DEI UPD
 */

import FI2.Set.InspectableKeyBasedContainer;
import FI2.Set.ObjectIterator;
import FI2.Exceptions.InvalidKeyException;

/**{i}
 * dizionario con metodi a sola lettura -
 * puo` contenere anche piu` elementi con la stessa
 * chiave
 * @see InspectableKeyBasedContainer
 */
public interface InspectableDictionary 
  extends InspectableKeyBasedContainer 
{

    /**{e}
     * elemento speciale ritornato da metodi di ricerca e 
     * rimozione quando la chiave non viene trovata -
     * consente di poter inserire nel dizionario elementi
     * null 
    */
    public static Object NO_SUCH_KEY = 
      new String ("Dictionary.NO_SUCH_KEY");

    /**[m][a]
     * ricerca per chiave di un elemento -
     * in caso di chiavi multiple, restituisce la prima
     * occorrenza
     * @param key  chiave di ricerca
     * @return l'elemento se chiave trovata,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object findElement (Object key) 
      throws InvalidKeyException;
  
    /**[m][a]
     * ricerca per chiave di elementi -
     * iterazione di tutti gli elementi con la
     * stessa chiave
     * @param key  chiave di ricerca
     * @return iteratore (eventualmente vuoto) 
     *         delle chiavi rimosse,
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public ObjectIterator findAllElements (Object key)
      throws InvalidKeyException;

} //{i} InspectableDictionary
