package FI2.Dictionary;
/**{p}
 * -- FI2.Dictionary --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Dizionari
 */

/**{f}
 * InspectableLocatorDictionary.java
 * interfaccia dizionario read-only
 * con supporto riferimenti (Locator)
 *
 * @version 1.00 00/09/25
 * @author M.Moro DEI UPD
 */

import FI2.Set.InspectableLocatorKeyBasedContainer;
import FI2.Set.LocatorIterator;
import FI2.Set.Locator;
import FI2.Exceptions.InvalidKeyException;

/**{i}
 * dizionario con metodi a sola lettura
 * e con supporto ai riferimenti (Locator)
 * @see InspectableLocatorKeyBasedContainer
 * @see InspectableDictionary
 */
public interface InspectableLocatorDictionary 
  extends InspectableLocatorKeyBasedContainer, InspectableDictionary 
{

    // l'elemento speciale NO_SUCH_KEY va ridefinito
    // nelle implementazioni come Locator

    /**[m][a]
     * ricerca per chiave di un elemento -
     * in caso di chiavi multiple, restituisce la prima
     * occorrenza
     * @param key  chiave di ricerca
     * @return un riferimento (Locator) 
     * all'elemento se chiave trovata,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Locator find(Object key) 
      throws InvalidKeyException;
  
    /**[m][a]
     * ricerca per chiave di elementi -
     * iterazione di tutti gli elementi con la
     * stessa chiave
     * @param key  chiave di ricerca
     * @return iteratore (eventualmente vuoto) 
     *         delle chiavi rimosse,
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public LocatorIterator findAll(Object key)
      throws InvalidKeyException;

} //{i} InspectableLocDictionary
