package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Biglietto.java
 * Esercizio 1.4 -
 * biglietto di autobus
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

/**{c}
 * Memorizza un biglietto a tariffa piena o ridotta
 * con totalizzatori
 */
public class Biglietto
{
    // la rappresentazione interna
    public static final int prezzo;
    private static int venduti;
    private static int ridotti;
    private static int obliterati;
    private final int numero;
    private boolean nuovo = true;

    // init statico
    static
    {
        prezzo = 1500;
        venduti = ridotti = obliterati = 0;
    }

    // costruttori

    /**[c]
     * costruttore di default
     */
    public Biglietto()
    { 
        numero = venduti; 
        venduti++;
    } //[c] Biglietto

    /**[c]
     * costruttore alternativo
     * @param dummy  per overloading
     */
    public Biglietto(int dummy)
    {
        numero = venduti; 
        venduti++;
        ridotti++;
    } //[c] Biglietto

    // metodi esportati

    /**[m]
     * obliterazione
     */
    public boolean oblitera()
    { 
        if (! nuovo)
            // gia` obliterato
            return false;
        nuovo = false;
        obliterati++;
        return true;
    } //[m] oblitera

    /**[m]
     * conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        return "Biglietto n. " + numero +
          " obliterato: " +
          (nuovo ? "no" : "si");
    } //[m] toString

    /**[m][s]
     * valori dei titalizzatori
     */
    public static String totali()
    {
        return "Biglietti venduti=" + venduti +
          " obliterati=" + obliterati +
          " ridotti=" + ridotti +
          " incasso=" + ((venduti-ridotti)*prezzo + ridotti*prezzo*9/10);
    } //[m][s] totali

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        Biglietto b0 = new Biglietto();
        Biglietto b1 = new Biglietto();
        Biglietto b2 = new Biglietto(0); // ridotto
        System.out.println("b0: " + b0);
        System.out.println("b1: " + b1);
        System.out.println("b2: " + b2);
        b1.oblitera();
        b2.oblitera();
        System.out.println("Dopo b1: " + b1);
        System.out.println("Dopo b2: " + b2);
        System.out.println("Di nuovo b2: " + b2.oblitera());
        System.out.println("Totali: " + Biglietto.totali());
    } //[m][s] main

} //{c} Biglietto
