package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Carnet.java
 * Esercizio 1.4 -
 * carnet di biglietti ridotti
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

/**{c}
 * Memorizza un carnet di biglietti ridotti
 */
public class Carnet
{
    // la rappresentazione interna
    private static final int BIGLIETTI = 10;
    private Biglietto c[];
    private static int venduti = 0;
    private int prossimo = 0;
    private boolean nuovo = true;

    // costruttori

    /**[c]
     * costruttore di default
     */
    public Carnet()
    { 
        c = new Biglietto[BIGLIETTI];
        for (int i=0; i<BIGLIETTI; i++)
            c[i] = new Biglietto(0);  // ridotto
        venduti++;
    } //[c] Carnet

    // metodi esportati

    /**[m]
     * obliterazione
     */
    public boolean oblitera()
    { 
        if (prossimo >= BIGLIETTI)
            // gia` tutto obliterato
            return false;

        c[prossimo++].oblitera();
        return true;
    } //[m] oblitera

    /**[m]
     * conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        return "Biglietto iniziale: " + c[0] + 
          " Biglietto finale: " + c[BIGLIETTI-1] + 
          " Biglietti non obliterati = " + (BIGLIETTI-prossimo);
    } //[m] toString

    /**[m][s]
     * valori dei titalizzatori
     */
    public static String totali()
    {
        return "Carnet venduti=" + venduti +
          " incasso carnet=" + (venduti*Biglietto.prezzo*BIGLIETTI*9/10);
    } //[m][s] totali

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        Carnet c0 = new Carnet();
        Carnet c1 = new Carnet();
        System.out.println("c0: " + c0);
        System.out.println("c1: " + c1);
        c0.oblitera();
        c0.oblitera();
        c0.oblitera();
        c0.oblitera();
        System.out.println("Dopo c0: " + c0);
        System.out.println("Totali: " + Carnet.totali());
    } //[m][s] main

} //{c} Carnet

