package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi
 */

/**{f}
 * Color.java
 * Colore di testo
 *
 * @version 3.00 01/09/30
 * @author M.Moro DEI UPD
 */

/**{c}
 * Colore per il testo su VGA
 */
public class Color
{
    // colori impostabili
    public static final int BLACK = 0;
    public static final int BLUE = 1;
    public static final int GREEN = 2;
    public static final int CYAN = 3;
    public static final int RED = 4;
    public static final int MAGENTA = 5;
    public static final int BROWN = 6;
    public static final int LIGHTGRAY = 7;
    public static final int DARKGRAY = 8;
    public static final int LIGHTBLUE = 9;
    public static final int LIGHTGREEN = 10;
    public static final int LIGHTCYAN = 11;
    public static final int LIGHTRED = 12;
    public static final int LIGHTMAGENTA = 13;
    public static final int YELLOW = 14;
    public static final int WHITE = 15;
    public static final int BLINK = 128;
        // BLINK e` in realta` rappresentato come byte 
        // (con segno) da -128

    protected byte col; // colore
    private static String col2Str[] = {
      "BLACK",
      "BLUE",
      "GREEN",
      "CYAN",
      "RED",
      "MAGENTA",
      "BROWN",
      "LIGHTGRAY",
      "DARKGRAY",
      "LIGHTBLUE",
      "LIGHTGREEN",
      "LIGHTCYAN",
      "LIGHTRED",
      "LIGHTMAGENTA",
      "YELLOW",
      "WHITE",
      "BLINK"
      };
        // usata da toString

    /**[c]
     * costruttore base
     * per generalita` con parametro int
     * @param col  colore da assegnare
     */
    public Color(int col)
    {
        this.col = (byte)col;
            // cast obbligatorio
    } //[c] Color

    /**[c]
     * costruttore di default
     */
    public Color()
    {
        this(WHITE);
    } //[c] Color

    /**[m]
     * colore con codifica intera
     * @return il colore
     */
    public int val()
    {
        return col;
    } //[m] Val

    /**[m]
     * luminosita` in 4 gradi (BLACK=0..3=WHITE)
     * @return la luminosita` del colore 
     */
    public int brightness()
    {
        if (col == (byte)BLACK)
            return 0;
        if (col == (byte)WHITE)
            return 3;
        if (col <= (byte)BROWN || col == (byte)DARKGRAY)
            return 1;
        // altri casi
        return 2;
    } //[m] brightness

    /**[m]
     * ridefinisce il metodo Object.equals()
     * @param sndC  secondo colore di confronto
     * @return true se valore colore eguale 
     */
    public boolean equals(Object sndC)
    {
        return col == ((Color)sndC).col;
    } //[m] equals

    /**[m]
     * conversione a stringa
     * @return descrizione del colore
     */
    public String toString()
    {
        return "{Color} " + ((col == (byte)BLINK) ?
          col2Str[WHITE+1] : col2Str[col]);
    } //[m] toString

    /**[m][s]
     * metodo di collaudo
     * @param args[]  non usato
     */
    public static void main(String[] args)
    {
        Color cc;

        for(int i=BLACK; i<=WHITE; i++) {
            cc = new Color(i);
            System.out.println(
              "Colore " + cc + " vale " + cc.col);
        }
        cc = new Color(BLINK);
        System.out.println(
          "Colore " + cc + " vale " + cc.col);
    } //[m][s] main

} //{c} Color

