package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * EBits.java
 * Esercizio 2.2 -
 * forma estensibile di Bits
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

/**{c}
 * Memorizza una sequenza di 32 bit in un intero
 */
public class EBits 
{
    // la rappresentazione interna
    protected int val;

    // costruttori

    /**[c]
     * costruttore di default
     */
    public EBits()
    { val = 0; } 

    /**[c]
     * costruttore base
     * @param sVal  valore come stringa
     */
    public EBits(String sVal)
    {
        val = 0;
        for (int i=0; i<sVal.length(); i++)
            switch (sVal.charAt(i))
            {
            case '0':
                val = (val << 1);
                break;
            case '1':
                val = (val << 1) | 1;
                break;
            default:
                // carattere illegale: ignora
                break;
            } // switch
    } //[c] Bits

    /**[c]
     * costruttore di supporto ai metodi statici
     * @param v  valore da assegnare
     */
    protected EBits(int v)
    {  val = v; }

    // metodi esportati

    /**[m]
     * and bitwise d'istanza
     * @param sndB  secondo Bits
     */
    public void and(EBits sndB)
    { val &= sndB.val; } 

    /**[m]
     * and bitwise statico
     * @param fstB  primo EBits
     * @param sndB  secondo EBits
     * @return EBits risultato
     */
    public static EBits and(EBits fstB, EBits sndB)
    { return new EBits (fstB.val & sndB.val); } 

    /**[m]
     * or bitwise d'istanza
     * @param sndB  secondo EBits
     */
    public void or(EBits sndB)
    { val |= sndB.val; } 

    /**[m]
     * or bitwise statico
     * @param fstB  primo EBits
     * @param sndB  secondo EBits
     * @return EBits risultato
     */
    public static EBits or(EBits fstB, EBits sndB)
    { return new EBits (fstB.val | sndB.val); } 

    /**[m]
     * not bitwise d'istanza
     */
    public void not()
    { val = ~val; } 

    /**[m]
     * not bitwise statico
     * @param b  EBits da negare
     * @return EBits risultato
     */
    public static EBits not(EBits b)
    { return new EBits (~b.val); } 

    /**[m]
     * query del bit
     * @param idx  indice del bit
     * @return EBits risultato
     */
    public boolean bit(int idx)
    { return (val & (1 << (idx % 32))) != 0; } 

    /**[m]
     * @param sndB  secondo EBits
     * @return true se le corrispondenti componenti
     * sono eguali
     */
    public boolean equals(EBits sndB)
    {  return val == sndB.val; }

    /**[m]
     * conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        String tmp = "{EBits} val=";
        int i;
        for (i=31; !bit(i) && i>=0; i--);
            // salta 0 non significativi
        if (i<0)
            // valore nullo
            tmp += "0";
        else
            for (; i>=0; i--)
                tmp += bit(i) ? "1" : "0";
        // potrebbe essere piu` efficiente utilizzare
        // uno StringBuffer anziche' uno String
        return tmp;
    } //[m] toString

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        System.out.println("EBits nullo: " + new EBits());
        EBits myEBits1 = new EBits("100001");
        EBits myEBits2 = new EBits("1101");

        System.out.println("100001 bit(5) = " + myEBits1.bit(5));
        System.out.println("100001 bit(4) = " + myEBits1.bit(4));
        System.out.println("100001 bit(0) = " + myEBits1.bit(0));

        System.out.println("100001 & 1101 = " + and(myEBits1, myEBits2));
        System.out.println("100001 | 1101 = " + or(myEBits1, myEBits2));
        System.out.println("~ 100001 = " + not(myEBits1));
        myEBits1.or(new EBits("1000"));
        System.out.println("Dopo 100001 | 1000 = " + myEBits1);
        System.out.println("bits1 e` " + 
          (myEBits1.equals(myEBits2) ? "eguale a" : "diverso da") + " bits2");
    } //[m][s] main

} //{c} EBits

