package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi vari
 */

/**{f}
 * Misure.java
 * Esercizio suppl. 1.2 -
 * una misura
 *
 * @version 1.00 00/10/03
 * @author M.Moro DEI UPD
 */

/**{c}
 * Memorizza una misura con l'unita`
 */
public class Misure
{
    // la rappresentazione interna
    protected float val;  // valore della misura
    protected String unit;  // unita` della misura

    // costruttori

    /**[c]
     * costruttore base
     * @param v  valore
     * @param u  unita`
     */
    public Misure(float v, String u)
    { 
        val = v;
        unit = u;
    } //[c]

    /**[c]
     * costruttore di default
     */
    public Misure()
    { 
        val = 0;
        unit = "";
    } //[c]

    // metodi esportati

    /**[m]
     * valore
     * @return il valore memorizzato
     */
    public float getv() { return val; }

    /**[m]
     * unita`
     * @return l'unita` di misura
     */
    public String getu() { return unit; }

    /**[m]
     * valore 'incapsulato'
     * @return il valore come Float
     */
    public Float getd() { return new Float(val); }

    /**[m]
     * valore e unita`
     * @return il valore e l'unita` come unica stringa
     */
    public String gets() 
    { 
        return Float.toString(val) + " " + unit; 
    } //[m] gets

    public void set(float v, String u)
    { 
        val = v;
        unit = u;
    } //[m] set
    
    /**[m]
     * ridefinisce il metodo Object.equals()
     * @param sndM  seconda misura di confronto
     * @return true se le corrispondenti componenti
     * sono eguali
     */
    public boolean equals(Object sndM)
    {
        return val == ((Misure)sndM).val &&
          unit.equals(((Misure)sndM).unit);
    } //[m] equals

    /**[m]
     * conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        return "{Misure} " + gets();
    } //[m] toString

    /**[m]
     * somma
     * @param val2  seconda misura da sommare
     * @return la somma tra this e val2
     * @exception IllegalArgumentException  
     * se l'unita` di this e` diversa da quella di val2
     */
    public Misure add(Misure val2)
    {
        if (!unit.equals(val2.unit))
            // unita` di misura diverse
            throw new IllegalArgumentException(
              "unita` difformi " + unit + ", " + val2.unit);
        return new Misure(val+val2.val, unit);
    }

    /**[m]
     * somma versione statica
     * @param val1  prima misura da sommare
     * @param val2  seconda misura da sommare
     * @return la somma tra val1 e val2
     * @exception IllegalArgumentException  
     * se l'unita` di val1 e` diversa da quella di val2
     */
    public static Misure add(Misure val1, Misure val2)
    {
        // si sfrutta l'altra
        return val1.add(val2);
    }

    /**[m]
     * opposto -
     * modifica this in modo che rappresenti il valore
     * opposto all'attuale
     */
    public void opp()
    {
        val = -val;
    }

// non richiesto

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        Misure m1 = new Misure (10, "cm");
        Misure m2 = new Misure (10, "dm");
        Misure m3 = new Misure (4, "cm");
        Misure m4 = new Misure (10, "dm");
        
        System.out.println("m1 = " + m1);
        System.out.println("m2 = " + m2);
        System.out.println("m3 = " + m3);
        System.out.println("m4 = " + m4);
        System.out.println("m1+m3 = " + Misure.add(m1,m3));
        System.out.println("m1 " + 
          (m1.equals(m2) ? "e`" : "non e`") + " eguale a m2");
        System.out.println("m2 " + 
          (m2.equals(m4) ? "e`" : "non e`") + " eguale a m4");
        m4.opp();
        System.out.println("m4 reso opposto e` = " + m4);
        System.out.println("Ora solleva eccezione!");
        Misure m5 = m4.add(m3);
    } //[m][s] main

} //{c} Misure

