package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Poligono.java
 * Esercizio 2.3 -
 * Una figura di poligono
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * Memorizza gli n vertici del poligono e il
 * valore n
 * @see Figura
 */
public class Poligono extends Figura
{
    // la rappresentazione interna
    protected int nVertici;
    protected PointE vertici[];

    // costruttori

    /**[c]
     * costruttore base
     * @param n  numero vertici
     * @param v  coordinate assolute dei vertici
     *
     */
    public Poligono(int n, PointE v[])
    { 
        // n e` assunto >= 4
        // per n=3 viene un punto medio su un lato
        super(new 
          PointE(
          (v[0].xVal()+v[2].xVal())/2, 
          (v[0].yVal()+v[2].yVal())/2
          ));
            // punto medio tra due vertici non adiacenti
        nVertici = n;
        vertici = new PointE[n];
        for (int i=0; i<n; i++)
            vertici[i] = new PointE(
              v[i].xVal()-centro.xVal(),
              v[i].yVal()-centro.yVal()
            );
            // vettore congiungente vertice-centro
    } //[c]

    // metodi esportati

    /**[m]
     * rotazione
     * @see SuFigura
     */
    public void rotate(double angolo)
    { 
        for (int i=0; i<nVertici; i++)
            vertici[i].rot(angolo);
    } //[m] rotate

    /**[m]
     * zoom
     * @see SuFigura
     */
    public void zoom(double fattore)
    { 
        for (int i=0; i<nVertici; i++)
            vertici[i] = new PointE(
              vertici[i].xVal()*fattore,
              vertici[i].yVal()*fattore
            );
    } //[m] zoom

    /**[m]
     * show
     * @see SuFigura
     */
    public void show()
    { 
        System.out.println("{Poligono} centro=" + 
          centro);
        System.out.println(" vertici (posizioni assolute):");
        for (int i=0; i<nVertici; i++)
            System.out.println("vertice " + i + " " +
              new PointE(
              vertici[i].xVal()+centro.xVal(),
              vertici[i].yVal()+centro.yVal()
              ));
    } //[m] show

    /**[m]
     * perimetro
     * @return il perimetro
     */
    public double perim()
    { 
        // indipendente dalla posizione del centro
        double pp = 0;
        for (int i=0; i<nVertici; i++)
            pp += vertici[i].dist(vertici[(i+1)%nVertici]);
              // somma delle distanze successive
        return pp;
    } //[m] perim

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
      throws IOException
    {
        PointE v[] = new PointE[4];
        v[0] = new PointE(1.0, 2.0);
        v[1] = new PointE(1.0, 4.0);
        v[2] = new PointE(1.5, 5.0);
        v[3] = new PointE(2.5, 1.0);
/* con un rettangolo parallelo agli assi        
        v[0] = new PointE(1.0, 2.0);
        v[1] = new PointE(1.0, 4.0);
        v[2] = new PointE(4.0, 4.0);
        v[3] = new PointE(4.0, 2.0); 
*/
        Poligono p = new Poligono(4, v);
        System.out.println("Poligono originario");
        p.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro originario = " + p.perim());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        p.move(new PointE(3.0, 5.0));
        System.out.println("Poligono dopo move (3,5)");
        p.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        p.rotate(Math.PI/2);
        System.out.println("Poligono dopo rot(PI/2)");
        p.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + p.perim());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        p.zoom(2.0);
        System.out.println("Poligono dopo zoom(2)");
        p.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + p.perim());
    } //[m][s] main

} //{c} Poligono

