package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * SBits.java
 * Esercizio 2.2 -
 * estende EBits con shift
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

/**{c}
 * Estende EBits con possibilita` di shifting
 * nei due versi
 */
public class SBits extends EBits implements Cloneable
{
    // verso di shift
    private static final int LEFT = 1;
    private static final int RIGHT = 2;
    private int shiftFlag;

    // costruttori

    /**[c]
     * costruttore di default
     * @see EBits
     */
    public SBits()
    { 
        super();
        shiftFlag = LEFT; 
    }  

    /**[c]
     * costruttore base
     * @param sVal  valore come stringa
     * @see EBits
     */
    public SBits(String sVal)
    {
        super(sVal);
        shiftFlag = RIGHT; 
    } 

    /**[c]
     * costruttore base
     * @param sVal  valore come stringa
     * @param isLeft  true se LEFT, false se RIGHT
     */
    public SBits(String sVal, boolean isLeft)
    {
        super(sVal);
        shiftFlag = isLeft ? LEFT : RIGHT; 
    } 

    /**[c]
     * clone
     * @see Object
     */
    public Object clone() 
      throws CloneNotSupportedException
    {
        return super.clone();
    } 

    /**[m]
     * or bitwise d'istanza ridefinito
     * @param sndB  secondo Bits
     * @see EBits
     */
    public void or(EBits sndB)
    {
        not();
        and(not(sndB));
        not();
    }

    /**[m]
     * ridefinisce conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        return super.toString() +
          " shiftFlag = " +
          (shiftFlag == LEFT ?
          "LEFT" : "RIGHT");
    } //[m] toString

    /**[m]
     * shift
     * @param n  numero passi (modulo 32)
     */
    public void shift(int n)
    {
        if (shiftFlag == LEFT)
            val <<= (n % 32);
        else
            val >>= (n % 32);
    } //[m] shift

    /**[m]
     * rotate
     * @param n  numero passi (modulo 32)
     */
    public void rot(int n)
    {
        if (shiftFlag == LEFT)
            // left
            for (int i=0; i<(n%32); i++)
                val = (val << 1) | (((val & 0x80000000) != 0) ? 1 : 0);
                    // riporta a destra il bit che esce a sinistra
        else
            // right
            for (int i=0; i<(n%32); i++)
                val = ((val >> 1) & 0x7fffffff) | 
                  (((val & 1) != 0) ? 0x80000000 : 0);
                    // riporta a sinistra il bit che esce a destra
    } //[m] rot

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        System.out.println("SBits nullo: " + new SBits());
        SBits mySBits1 = new SBits("100001", true);
        SBits mySBits2 = new SBits("1101", false);
        System.out.println("100001 bit(5) = " + mySBits1.bit(5));
        try
        {
            SBits mySCopy1 = (SBits)mySBits1.clone();
            mySCopy1.or(mySBits2);
            System.out.println("100001 | 1101 = " + mySCopy1);
        }
        catch (CloneNotSupportedException e)
        {
            System.out.println("Non ha clonato: "+e);
        }

        SBits mySBits3 = new SBits(or(mySBits1, new SBits("1101")).toString(), 
          false);
        mySBits1.shift(2);
        System.out.println("101101 << 2 = " + mySBits1);
        mySBits2.shift(2);
        System.out.println("1101 >> 2 = " + mySBits2);
        mySBits1.rot(4);
        System.out.println("bits1 rot 4 = " + mySBits1);

        System.out.println("bit3 = " + mySBits3);
        mySBits3.rot(4);
        System.out.println("101101 right rot 4 = " + mySBits3);
    } //[m][s] main

} //{c} SBits

