package FI2.Graph;
/**{p}
 * -- FI2.Graph --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Grafi
 */

/**{f}
 * FindAllVerticesDFS.java
 * specializzazione di DFS per enumerare tutti
 * i vertici di un grafo -
 * software ricavato dalla libreria JDSL
 *
 * @version 1.00 98/09/24
 * @author M.Moro DEI UPD
 */

/*
 * Copyright (C) 1998, Center for Geometric Computing, Brown University
 *                 and The Johns Hopkins University
 * 
 * All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a  
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that   
 * copyright notice and this permission notice appear in supporting 
 * documentation, and that the names of Brown University and of The Johns
 * Hopkins University not be used in advertising or publicity pertaining
 * to distribution of the software without specific, written prior
 * permission.
 * 
 * BROWN UNIVERSITY AND THE JOHNS HOPKINS UNIVERSITY DISCLAIM ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR  
 * PURPOSE. IN NO EVENT SHALL BROWN UNIVERSITY OR THE JOHNS HOPKINS
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL 
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * @(#)FindAllVerticesDFS.java  Sun Aug 31 19:11:49 1997
 * Natasha Gelfand
 */

//package jdsl.core.algo.graphtraversals;


import java.io.*;
import FI2.Set.ObjectIterator;
import FI2.Linear.Sequence;
import FI2.Linear.ArraySequence;
import FI2.Dictionary.SeparateChainingHashTable;
import FI2.Util.FI2Sys;

/**
 * This class specializes DFS to return an enumeration of 
 * the vertices in  the connected component of the start
 * vertex. The vertices are returned
 * in the order they were examined by DFS.
 *   
 * @version JSDL-Teach release 1.0
 * @author Natasha Gelfand
 */

//# This class specializes DFS to return an enumeration 
//# of the vertices in  
//# the connected component of the start vertex.

public class FindAllVerticesDFS extends DFS {
  protected Sequence vertices;

  public Object execute(InspectableGraph g, 
    Vertex start, Object info) {
    super.execute(g, start, info);
//    vertices = new NodeSequence();

      vertices = new ArraySequence();
    dfsVisit(start);
    return vertices.elements();
  }

  // This will add vertices in DFS order
  public void startVisit(Vertex v) {
    vertices.insertLast(v);
  }

    /**[m][s]
     * metodo di collaudo
     * @param args  non usato
     */
    public static void main(String[] args)
    {
        Graph myGraph = new SILGraph();
        Vertex[] myVert = new Vertex[5];
        for (int i=0; i<5; i++)
        {
            String str = "Vertice " + i;
            myVert[i] = myGraph.insertVertex(str);
        }
        myGraph.insertEdge(myVert[0], myVert[1], "Arco a");
        myGraph.insertEdge(myVert[0], myVert[4], "Arco b");
        myGraph.insertEdge(myVert[1], myVert[2], "Arco c");
        myGraph.insertEdge(myVert[1], myVert[3], "Arco d");
        myGraph.insertEdge(myVert[3], myVert[4], "Arco e");

        FindAllVerticesDFS myDFS = new FindAllVerticesDFS();
        ObjectIterator en = 
          (ObjectIterator)myDFS.execute(myGraph, myVert[0], "");

        FI2Sys.out.println("\nI vertici:");
        while (en.hasNext())
            FI2Sys.out.println("Vertice " + en.nextObject());
    } //[m][s] main

} //{c} FindAllVerticesDFS
