package FI2.Graph;
/**{p}
 * -- FI2.Graph --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Grafi
 */

/**{f}
 * FindPathDFS.java
 * specializzazione di DFS per la ricerca di cammini -
 * software ricavato dalla libreria JDSL
 *
 * @version 2.00 00/09/28
 * @author M.Moro DEI UPD
 */

/*
 * Copyright (C) 1998, Center for Geometric Computing, Brown University
 *                 and The Johns Hopkins University
 * 
 * All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a  
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that   
 * copyright notice and this permission notice appear in supporting 
 * documentation, and that the names of Brown University and of The Johns
 * Hopkins University not be used in advertising or publicity pertaining
 * to distribution of the software without specific, written prior
 * permission.
 * 
 * BROWN UNIVERSITY AND THE JOHNS HOPKINS UNIVERSITY DISCLAIM ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR  
 * PURPOSE. IN NO EVENT SHALL BROWN UNIVERSITY OR THE JOHNS HOPKINS
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL 
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * @(#)FindPathDFS.java  Tue Sep  2 16:41:23 1997
 * Natasha Gelfand
 */

//package jdsl.core.algo.graphtraversals;

import java.io.*;
import FI2.Set.ObjectIterator;
import FI2.Linear.Sequence;
import FI2.Linear.ArraySequence;
import FI2.Util.FI2Sys;



/**
 * This class specializes DFS to determine, given a vertex v, 
 * if there is a path from the start vertex to v in the 
 * connected component of the start vertex. The algorithm 
 * returns an enumeration of vertices in the
 * path, or an empty enumeration if the path does not exist.
 *
 * @version JSDL-Teach release 1.0
 * @author Natasha Gelfand
 */

// This class specializes DFS to determine if there is a path 
// from a start vertex to a target vertex. It returns an 
// enumeration of vertices in the path, or an empty 
// enumeration if such a path does not exist.  
// The algorithm performs a DFS beginning at the start vertex.
public class FindPathDFS extends DFS {
  protected Sequence path;
  protected boolean done;
  protected Vertex targetVert;

  public Object execute(InspectableGraph g, 
    Vertex start, Object info) {
    super.execute(g, start, info);
//    path = new NodeSequence();
    path = new ArraySequence();
    done = false;
    targetVert = (Vertex)info; 
      // target vertex is stored in info parameter
    dfsVisit(start);
    return path.elements();
  }

  protected void startVisit(Vertex v) {
    path.insertFirst(v); 
    if (v == targetVert) { done = true; }
  }

  protected void finishVisit(Vertex v) {
    if (!done) { path.remove(path.first()); }
  }

  protected boolean isDone() { return done; }

    /**[m][s]
     * metodo di collaudo
     * @param args  non usato
     */
    public static void main(String[] args)
    {
        Graph myGraph = new SILGraph();
        Vertex[] myVert = new Vertex[5];
        for (int i=0; i<5; i++)
        {
            String str = "Vertice " + i;
            myVert[i] = myGraph.insertVertex(str);
        }
        myGraph.insertEdge(myVert[0], myVert[1], "Arco a");
        myGraph.insertEdge(myVert[0], myVert[4], "Arco b");
        myGraph.insertEdge(myVert[1], myVert[2], "Arco c");
        myGraph.insertEdge(myVert[1], myVert[3], "Arco d");
        myGraph.insertEdge(myVert[3], myVert[4], "Arco e");

        FI2Sys.out.println("Archi:");
        for (int i=0; i<5; i++)
            for (ObjectIterator inEdges = 
              myGraph.incidentEdges(myVert[i]);
              inEdges.hasNext(); )
                FI2Sys.out.println("Da " + myVert[i] + ": " +
                  inEdges.nextObject());

        FindPathDFS myDFS = new FindPathDFS();
        ObjectIterator en = 
          (ObjectIterator)myDFS.execute(myGraph, myVert[2], 
          myVert[4]);

        FI2Sys.out.println("\nPath da " + myVert[2] +
          " a " + myVert[4]);
        while (en.hasNext())
            FI2Sys.out.println("Path " + en.nextObject());
    } //[m] main

} //{c} FindPathDFS
