package FI2.Gui;
/**{p}
 * -- FI2.Gui --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * DialogFrame.java
 * esempio di Frame con finestra dialogo
 *
 * @version 1.00 98/12/08
 * @author M.Moro DEI UPD
 */

import java.awt.*;
import java.awt.event.*;

/**{c}
 * esempio di frame che apre una finestra di dialogo -
 * implementa alcuni ascoltatori
 */
public class DialogFrame extends Frame 
  implements ActionListener, WindowListener 
{

    Dialog dialog;
    Button openDialogButton;
    Button closeDialogButton;
    Button closeFrameButton;
    
    /**[c]
     * costruttore base, aggiunge al frame tutti i
     * componenti previsti
     */
    public DialogFrame() 
    {
        super("Dialog and Frame example");
        setLayout(new FlowLayout());
        addWindowListener(this);
        
        openDialogButton = new Button("Open dialog");
        openDialogButton.addActionListener(this);
        
        closeFrameButton = new Button("Close me");
        closeFrameButton.addActionListener(this);
        
        add(openDialogButton);
        add(closeFrameButton);
        
        pack();
        show();
    } //[c] DialogFrame
    
    /**[m]
     * apertura di una finestra di dialogo
     */
    public void showDialog() 
    {
        dialog = new Dialog(this, "This is the dialog", true);
        dialog.setLayout(new FlowLayout());
        dialog.addWindowListener(this);
        
        closeDialogButton = new Button("Close dialog");
        closeDialogButton.addActionListener(this);
        
        dialog.add(closeDialogButton);
        
        dialog.pack();
        dialog.show();
    } //[m] showDialog
    
    /**[m]
     * implementazione di ActionListener
     * @see ActionListener
     */
    public void actionPerformed(ActionEvent e) 
    {
        String buttonCommand = e.getActionCommand();
        if(buttonCommand.equals("Open dialog"))
            showDialog();
        else if(buttonCommand.equals("Close dialog"))
            dialog.dispose();
        else if(buttonCommand.equals("Close me"))
            processEvent(new WindowEvent(this, 
              WindowEvent.WINDOW_CLOSING));
            //EventQueue.getEventQueue().postEvent(
            // new WindowEvent(this, 
            // WindowEvent.WINDOW_CLOSING));
    } //[m] actionPerformed
    
    /**[m]
     * implementazione di WindowListener
     * @see WindowListener
     */
    public void windowClosing(WindowEvent e) 
    {
        Window originator = e.getWindow();
        if(originator.equals(this)) 
        {
            this.dispose();
            System.exit(0);
        } 
        else if(originator.equals(dialog))
            dialog.dispose();
    } //[m] windowClosing
    
    public void windowActivated(WindowEvent e) { }
    public void windowDeactivated(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowClosed(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }

    /**[m][s]
     * metodo di attivazione
     * @param args[]  non usato
     */
    public static void main(String[] args) 
    {
        DialogFrame me = new DialogFrame();
    } //[m][s] main

} //{c} DialogFrame
