package FI2.Gui;
/**{p}
 * -- FI2 --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * InorderDrawApplet.java
 * Visualizzazione grafica in applet di un albero
 * mediante visita in ordine -
 * software ricavato dalla libreria JDSL
 *
 * @version 3.00 00/09/29
 * @author M.Moro DEI UPD
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import FI2.Tree.*;

/**{c}
 * effettua la visualizzazione grafica di un albero
 * generato casualmente
 */
public class InorderDrawApplet 
  extends Applet implements ActionListener 
  {
  private int numExt = 16;
  private RandomTreeBuilder builder;
  private InorderDrawTraversal inorder;
  private CanvasDrawTraversal canvas;
  private BinaryTree tree;
  public void init() {
    setLayout(new BorderLayout());
    // create a random tree and draw it
    builder = new RandomTreeBuilder();
    inorder = new InorderDrawTraversal();
    canvas = new CanvasDrawTraversal(getGraphics());
    tree = builder.randomBinaryTree(numExt);
    inorder.execute(tree);
    canvas.execute(tree);
    // create a button that will draw 
    // a new tree when it is clicked
    Panel p = new Panel();
    p.setLayout(new FlowLayout());
    Button newTree = new Button("Draw New Tree");
    newTree.addActionListener(this);
    p.add(newTree);
    add("South", p);
  }
  public void paint(Graphics g) {
    canvas.execute(tree);
  }
  public void actionPerformed(ActionEvent e) {
    repaint();
    tree = builder.randomBinaryTree(numExt);
    inorder.execute(tree);
    canvas.execute(tree);
  }
} //{c} InorderDrawApplet

