package FI2.Gui;
/**{p}
 * -- FI2 --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * InorderDrawTraversal.java
 * Disegno mediante attraversamento in ordine 
 * di un albero binario -
 * software ricavato dalla libreria JDSL
 *
 * @version 3.00 00/09/29
 * @author M.Moro DEI UPD
 */

import FI2.Set.*;
import FI2.Tree.*;

/**{c}
 * effettua la visualizzazione grafica di un albero
 * binario mediante visita in ordine
 */
public class InorderDrawTraversal 
  extends EulerTour {
  // Computation of a straight-line 
  // drawing of a binary tree where the
  // the x-coordinate of a node is its inorder rank and the
  // y-coordinate is its depth..
  protected int rank  = 0;
  protected int depth = 0;
  public Object execute(BinaryTree T) {
    super.execute(T);
    rank = 0;
    depth = 0;
    this.eulerTour(T.root());
    return null;   // nothing interesting to return
  }
  protected void visitExternal(Position p, TraversalResult r) {
    ((DrawingInfo)p.element()).setX(rank++);
    ((DrawingInfo)p.element()).setY(depth);
  }
  protected void visitLeft(Position p, TraversalResult r) 
    { depth++; }
  protected void visitBelow(Position p, TraversalResult r) {
    depth--;
    ((DrawingInfo)p.element()).setX(rank++);
    ((DrawingInfo)p.element()).setY(depth);
    depth++;
  }
  protected void visitRight(Position p, TraversalResult r) 
    { depth--; }
} //{c} InorderDrawTraversal

