package FI2.Gui;
/**{p}
 * -- FI2 --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * RandomTreeBuilder.java
 * costruzione albero casuale
 * software ricavato dalla libreria JDSL
 *
 * @version 2.00 00/09/29
 * @author M.Moro DEI UPD
 */

/*
 * Copyright (C) 1998, Center for Geometric Computing, 
 * Brown University
 *                 and The Johns Hopkins University
 * 
 * All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a  
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that   
 * copyright notice and this permission notice appear in supporting 
 * documentation, and that the names of Brown University and of The Johns
 * Hopkins University not be used in advertising or publicity pertaining
 * to distribution of the software without specific, written prior
 * permission.
 * 
 * BROWN UNIVERSITY AND THE JOHNS HOPKINS UNIVERSITY DISCLAIM ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR  
 * PURPOSE. IN NO EVENT SHALL BROWN UNIVERSITY OR THE JOHNS HOPKINS
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL 
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

import java.util.Random;
import java.awt.Color;
import FI2.Set.*;
import FI2.Tree.*;

/**{c}
 * genera casualmente un albero binario
 */
public class RandomTreeBuilder 
  {
  protected static int count = 1;
  protected Random gen = new Random();  
  protected ExpandBinaryTree tree;
  public ExpandBinaryTree randomBinaryTree(int n) {
    // Create a random binary tree with n external nodes
    System.out.println
      ("Building random binary tree " + (count++) +
      " with " + n + 
      " external nodes ...");
    tree = new LinkedBinaryTree();
    build(tree.root(), n);  // auxiliary recursive method
    return tree;
  }
  protected void build(Position p, int n) {
    // Auxiliary method used by 
    // randomBinaryTree that recursively builds
    // a tree rooted at position p with n external nodes
    if (tree.isExternal(p) && n > 1) {
      // make a new internal node and 
      // assign to it a random color
      tree.expandExternal(p);
      tree.replaceElement(p, new DrawingInfo(randomColor()));
      // color black the newly created external nodes
      tree.replaceElement(tree.leftChild(p), 
        new DrawingInfo(Color.black));
      tree.replaceElement(tree.rightChild(p), 
        new DrawingInfo(Color.black));
      // generate random sizes for left and right subtrees
      int leftsize = randomInteger(1, n - 1);
      int rightsize = n-leftsize;
      // recursively build the left and right subtrees
      build(tree.leftChild(p), leftsize);
      build(tree.rightChild(p), rightsize);
    }
  }
  protected Color randomColor() {
    // Make a new color with random red, green and blue values
    int r = randomInteger(50, 255);
    int g = randomInteger(50, 255);
    int b = randomInteger(50, 255);
    return new Color(r, g, b);
  }
  protected int randomInteger(int min, int max) {
    // Return a random integer i such that min <= i <= max
    float r1 = gen.nextFloat();
    float r2 = min + r1*(max+1-min);
    return (int) r2;
  }
} //{c} RandomTreeBuilder
