package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * ArrayListPosition.java
 * posizionatore per Sequenza indicizzabile
 * (List e Sequence) -
 * corrisponde a SequencePosition della v 1.x 
 *
 * @version 2.00 00/09/20
 * @author M.Moro DEI UPD
 */

import FI2.Set.Container;

/**{c}
 * indicatore di posizione (posizionatore)
 * per una sequenza realizzata con una struttura
 * indicizzabile (ad esempio array)
 * @see GenericPosition
 */
public class ArrayListPosition extends GenericPosition
{
    private int idx; 
      // indice di accesso corrispondente

    /**[c]
     * costruttore di default
     */
    public ArrayListPosition()
    { this(null, null, -1); }

    /**[c]
     * costruttore effettivo
     * @param cont  
     * contenitore su cui il posizionatore agisce
     * @param elem  oggetto associato
     * @param index  indice corrispondente
     */
    protected  ArrayListPosition(Container cont, Object elem, 
      int index)
    {
        super(cont, elem);
        idx = index;
    } //[c] ArrayListPosition

    /**[m]
     * restituisce l'indice associato al posizionatore
     * @return indice del posizionatore
     */
    protected int index()
    { return idx; }

    /**[m]
     * aggiorna l'indice associato al posizionatore
     * @param index  nuovo indice
     */
    protected void setIndex(int index) 
    { idx = index; }

    /**[m] !!
     * conversione a stringa
     * @return stringa con il contenuto
     */
    public String toString()
    {
        return "Sequence Position: " + super.toString() +
          " idx=" + idx;
    } //[m] toString
     
} //{i} SequencePosition
