package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * InspectablePriorityQueue.java
 * interfaccia una coda a priorita`
 * read-only -
 * derivata da SimplePriorityQueue della v 1.x 
 *
 * @version 2.00 00/09/24
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.EmptyContainerException;
import FI2.Set.Container;
import FI2.Set.InspectableKeyBasedContainer;

/**{i}
 * coda a priorita` con metodi a sola lettura -
 * discende da un ordinamento totale a sua volta
 * conseguente ad un confronto mediante Comparator;
 * gli elementi della coda sono Item che includono
 * la chiave che guida inserimenti e confronti
 * @see Container
 */
public interface InspectablePriorityQueue 
  extends InspectableKeyBasedContainer 
{
    /**[m][a]
     * ricerca l'Item con chiave minima e
     * restituisce l'oggetto associato
     * @return oggetto corrispondente alla chiave minima
     * @exception EmptyContainerException 
     * se la coda e` vuota
     */
    Object minElement()
      throws EmptyContainerException;

	    /**[m][a]
     * ricerca la chiave minima
     * @return la chiave minima
     * @exception EmptyContainerException 
     * se la coda e` vuota
     */
    Object minKey()
      throws EmptyContainerException;
  
} //{i} InspectablePriorityQueue
