package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * InspectableSequence.java
 * interfaccia per una sequenza read-only -
 * raggruppa Vector e List -
 * derivata da Sequence della v 1.x 
 *
 * @version 2.00 00/09/20
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidPositionException;
import FI2.Exceptions.BoundaryViolationException;
import FI2.Set.Position;
import FI2.Set.InspectablePositionalContainer;

/**{i}
 * generica sequenza con accesso via posizionatore e via
 * indice con metodi a sola lettura
 */
public interface InspectableSequence 
  extends InspectablePositionalContainer
{
    /**[m][a]
     * il posizionatore dell'oggetto posizione fornita
     * viene sollevata l'eccezione indicata
     * se r<0 oppure r>size()-1
     * @param r  indice dell'elemento
     * @return  il posizionatore dell'oggetto 
     * se l'indice e` nel range
     * @exception BoundaryViolationException  indice illegale
     */
    Position atRank(int r) throws BoundaryViolationException;

    /**[m][a]
     * l'indice corrispondente al posizionatore dell'oggetto 
     * fornito
     * @param p  posizionatore
     * @return  indice corrispondente
     * @exception InvalidPositionException
     * posizionatore illegale
     */
    int rankOf(Position p) 
      throws InvalidPositionException;

} //{i} InspectableSequence
