package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * InspectableVector.java
 * interfaccia per una sequenza ad accesso indicizzato
 * read-only -
 * derivata da RankedSequence della v 1.x 
 *
 * @version 2.00 00/09/20
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.BoundaryViolationException;
import FI2.Set.InspectableContainer;

/**{i}
 * generica sequenza ad accesso indicizzato
 * con metodo a sola lettura
 * @see InspectableContainer
 */
public interface InspectableVector extends InspectableContainer
{
    /**[m][a]
     * oggetto in posizione fornita -
     * viene sollevata l'eccezione indicata
     * se r<0 oppure r>size()-1
     * @param r  indice dell'elemento
     * @return  l'oggetto se l'indice e` nel range
     * @exception BoundaryViolationException  indice illegale
     */
    Object elemAtRank(int r) 
      throws BoundaryViolationException;

} //{i} InspectableVector
