package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * PriorityQueue.java
 * interfaccia una coda a priorita` -
 * derivata da SimplePriorityQueue della v 1.x 
 *
 * @version 2.00 00/09/25
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.EmptyContainerException;
import FI2.Exceptions.InvalidKeyException;
import FI2.Set.Container;
import FI2.Set.KeyBasedContainer;

/**{i}
 * coda a priorita` -
 * discende da un ordinamento totale a sua volta
 * conseguente ad un confronto mediante Comparator;
 * gli elementi della coda sono Item che includono
 * la chiave che guida inserimenti e confronti -
 * c'e` una piccola differenza con [Good] pag. 290
 * poiche' qui, per uniformita`, estende Container
 * @see Container
 */
public interface PriorityQueue 
  extends InspectablePriorityQueue, KeyBasedContainer 
{
    /**[m][a]
     * inserisce un Item fondendo chiave e oggetto
     * forniti
     * @param key  la chiave
     * @param element  l'oggetto
     * @exception InvalidKeyException 
     * se chiave illegale
     */
    void insertItem(Object key, Object element)
      throws InvalidKeyException;
  
    /**[m][a]
     * rimuove l'Item con chiave minima
     * @return l'oggetto nell'Item rimosso
     * @exception EmptyContainerException 
     * se la coda e` vuota
     */
    Object removeMin()
      throws EmptyContainerException;
  
} //{i} PriorityQueue
