package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * Queue.java
 * interfaccia per una coda (FIFO)
 *
 * @version 2.00 98/08/02
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.QueueEmptyException;

/**{i}
 * generica coda FIFO -
 * potrebbe estendere un contenitore ma non viene fatto
 * per uniformita` con [Good] pag. 151
 */
public interface Queue
{
    // metodi di accesso

    /**[m][a]
     * numero degli elementi nella coda FIFO
     * @return numero elementi corrente
     */
    int size();

    /**[m][a]
     * verifica se coda FIFO vuota
     * @return true se coda FIFO vuota;
     *         false altrimenti
     */
    boolean isEmpty();

    /**[m][a]
     * oggetto in testa alla coda FIFO
     * @return  l'oggetto se la coda FIFO non e` vuota
     * @exception QueueEmptyException  coda FIFO vuota
     */
    Object front() throws QueueEmptyException;

    // metodi di aggiornamento

    /**[m][a]
     * inserisce un elemento come nuova coda -
     * qualche realizzazione puo` sollevare l'eccezione
     * QueueFullException
     * @param element  oggetto da inserire
     */
    void enqueue(Object element);

    /**[m][a]
     * rimuove un elemento dalla testa della coda FIFO
     * @return  l'oggetto se la coda FIFO non e` vuota
     * @exception QueueEmptyException  coda FIFO vuota
     */
    Object dequeue() throws QueueEmptyException;

} //{i} Queue
