package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * SLNode.java
 * Modello di nodo per una lista concatenata semplice
 *
 * @version 1.00 98/09/19
 * @author M.Moro DEI UPD
 */


/**{c}
 * nodo di lista concatenata semplice -
 * in [Good] pag. 160 e` nominato come Node ma conviene
 * chiamarlo SLNode per non confonderlo con il nodo di 
 * un albero o con altri tipi di nodi di struttura -
 * i metodi sono quasi tutti a visibilita` protected perche'
 * di uso interno ai metodi per strutture lineari ma
 * eventualmente ereditabili da classe estese in altri
 * package
 */
class SLNode
{
    private Object element;  // valore associato
    private SLNode next; // elemento successivo

    /**[c]
     * costruttore di default
     */
    public SLNode()
    { this(null, null); }

    /**[c]
     * costruttore con oggetto associato
     * @param e  l'oggetto associato
     * @param n  nodo successivo
     */
    protected SLNode(Object e, SLNode n)
    {
        element = e;
        next = n;
    } //[c] SLNode

    // metodi d'accesso

    /**[m]
     * metodo di lettura dell'oggetto
     * @return l'oggetto associato
     */
    protected Object getElement()
    { return element; }

    /**[m]
     * metodo di lettura del successore
     * @return riferimento al nodo successivo
     */
    protected SLNode getNext()
    { return next; }

    // metodi di aggiornamento

    /**[m]
     * metodo di modifica dell'oggetto
     * @param newElem l'oggetto da assegnare
     */
    protected void setElement(Object newElem)
    { element = newElem; }

    /**[m]
     * metodo di modifica del successore
     * @param newNext in nuovo nodo successivo
     */
    protected void setNext(SLNode newNext)
    { next = newNext; }

} //{c} SLNode
