package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * SLNodePosition.java
 * Modello di nodo per una lista concatenata semplice
 * che funga anche da posizionatore
 *
 * @version 1.00 98/09/19
 * @version 1.01 00/12/12 - 
 * getElement, setElement pleonastici
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidPositionException;
import FI2.Set.Container;
import FI2.Set.Position;

/**{c}
 * nodo di lista concatenata semplice -
 * estende SLNode in modo da renderlo anche
 * posizionatore -
 * sono dichiarati protected i metodi normalmente
 * di uso interno ai metodi per strutture lineari ma
 * eventualmente ereditabili da classe estese in altri
 * package
 * @see SLNode
 * @see Position
 */
class SLNodePosition extends SLNode implements Position
{
    private Container cont; 
      // contenitore su cui il posizionatore agisce

    /**[c]
     * costruttore di default
     */
    public SLNodePosition()
    { this(null, null, null); }

    /**[c]
     * costruttore con oggetto associato
     * @param c  il contenitore
     * @param e  l'oggetto associato
     * @param n  nodo successivo
     */
    protected SLNodePosition(Container c, Object e, 
      SLNodePosition n)
    {
        super(e, n);
        cont = c;
    } //[c] SLNodePosition

    /**[m]
     * per completezza, esistendo il costruttore nullo,
     * un posizionatore puo` effettivamente essere illegale
     * @see Position
     */
    public Object element() 
      throws InvalidPositionException
    {
        if (cont==null)
            throw new InvalidPositionException(
              "In SLNodePosition.element");
        return super.getElement();
    } //[m] element

    /**[m]
     * per completezza, esistendo il costruttore nullo,
     * un posizionatore puo` effettivamente essere illegale
     * @see Position
     */
    public Container container() 
      throws InvalidPositionException
    {
        if (cont==null)
            throw new InvalidPositionException(
              "In SLNodePosition.container");
        return cont;
    } //[m] container

    /**[m]
     * ritorna l'elemento 'indicato' dal posizionatore
     * assunto corretto
     * @return elemento associato
     */
/* ereditato     
    protected Object getElement() 
    { return super.getElement(); }
*/    

    /**[m]
     * aggiorna l'elemento 'indicato' dal posizionatore
     * @param elem  elemento da assegnare
     */
/* ereditato     
    protected void setElement(Object elem) 
    { super.setElement(elem); }
*/    

    /**[m]
     * rende non piu` valido il posizionatore
     */
    protected void setInvalid()
    { cont = null; }

    /**[m] !!
     * conversione a stringa
     * @return stringa con il contenuto
     */
    public String toString()
    {
        return "SLNode Position cont.size=" + cont.size() +
          " elem=" + super.getElement();
    } //[m] toString
     
} //{c} SLNodePosition
