package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * Stack.java
 * interfaccia per uno stack generico
 *
 * @version 2.00 98/08/19
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.StackEmptyException;

/**{i}
 * stack generico -
 * potrebbe estendere un contenitore ma non viene fatto
 * per uniformita` con [Good] pag. 139
 */
public interface Stack 
{
    // metodi di accesso

    /**[m][a]
     * numero degli elementi nello stack
     * @return numero elementi corrente
     */
    int size();

    /**[m][a]
     * verifica se stack vuoto
     * @return true se stack vuoto;
     *         false altrimenti
     */
    boolean isEmpty();

    /**[m][a]
     * oggetto in cima allo stack
     * @return  l'oggetto se lo stack non e` vuoto
     * @exception StackEmptyException  stack vuoto
     */
    Object top() throws StackEmptyException;


    // metodi di aggiornamento

    /**[m][a]
     * inserisce un elemento come nuova cima -
     * qualche realizzazione puo` sollevare l'eccezione
     * StackFullException
     * @param el  oggetto da inserire
     */
    void push(Object el);

    /**[m][a]
     * rimuove un elemento dalla cima
     * @return  l'oggetto se lo stack non e` vuoto
     * @exception StackEmptyException  stack vuoto
     */
    Object pop() throws StackEmptyException;

} //{i} Stack
