package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * Vector.java
 * interfaccia per una sequenza ad accesso indicizzato
 * read-write -
 * derivata da RankedSequence della v 1.x 
 *
 * @version 2.00 00/09/20
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.BoundaryViolationException;
import FI2.Set.Container;

/**{i}
 * generica sequenza ad accesso indicizzato
 * con metodi di modifica
 * @see InspectableVector
 * @see Container
 */
public interface Vector extends InspectableVector, Container
{
    /**[m][a]
     * sostituisce l'elemento all'indice indicato -
     * viene sollevata l'eccezione indicata
     * se r<0 oppure r>size()-1
     * @param r  indice dell'elemento
     * @param e  nuovo oggetto
     * @return l'oggetto sostituito
     * @exception BoundaryViolationException  indice illegale
     */
    Object replaceAtRank(int r, Object e)
      throws BoundaryViolationException;

    /**[m][a]
     * inserisce l'elemento all'indice indicato -
     * aumenta di uno l'indice di tutti gli elementi
     * precedentemente con indice > r -
     * viene sollevata l'eccezione indicata
     * se r<0 oppure r>size()
     * @param r  indice dell'elemento
     * @param e  nuovo oggetto
     * @exception BoundaryViolationException  indice illegale
     */
    void insertAtRank(int r, Object e)
      throws BoundaryViolationException;

    /**[m][a]
     * rimuove l'elemento all'indice indicato -
     * diminuisce di uno l'indice di tutti gli elementi
     * precedentemente con indice > r -
     * viene sollevata l'eccezione indicata
     * se r<0 oppure r>size()-1
     * @param r  indice dell'elemento
     * @return l'oggetto rimosso
     * @exception BoundaryViolationException  indice illegale
     */
    Object removeAtRank(int r)
      throws BoundaryViolationException;

} //{i} Vector
