package FI2.Network;
/**{p}
 * -- FI2.Network --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Rete
 */

/**{f}
 * ServerTCP.java
 * esempio di server su socket TCP
 *
 * @version 1.00 99/11/13
 * @author L.Calvi ITIS Negrelli Feltre (BL)
 * @author M.Moro DEI UPD
 */

import java.net.*;
import java.io.*;

/**{c}
 * esempio di server su porta TCP
 */
public class ServerTCP
{
    /**[m][s]
     * metodo di attivazione
     * @param args[0]  numero porta
     */
    public static void main(String[] args)
    {
        int i=0;  // N. del messaggio spedito al client
        ServerSocket ss = null;
        Socket s;
        int nporta;
        DataOutputStream dos;
        DataInputStream dis;

        if (args.length < 1)
        {
            System.out.println("Sintassi: java ServerTCP <nPortaServer>");
            System.exit(-1);
        }

        // numero della porta sulla quale il server si mette in ascolto
        nporta = Integer.parseInt(args[0]);

        // creazione di un oggetto ServerSocket in ascolto sulla porta nporta
        try { ss = new ServerSocket(nporta); }
        catch (IOException e) { }

        // ciclo ascolta/accept
        while (true)
        {
            // il server si mette in attesa di una connessione sulla porta
            System.out.println("Server in ascolto sulla porta "+nporta+" ...");

            try 
            {
                // il metodo accept crea e ritorna un riferimento ad un socket
                // mediante il quale connettersi al client
                s = ss.accept();

                // creazione di un DataOutputStream connesso
                // all'OutputStream del Socket s
                dos = new DataOutputStream(s.getOutputStream());

                // creazione di un DataInputStream connesso
                // all'InputStream del Socket s
                dis = new DataInputStream(s.getInputStream());


                while (true)
                {
                    String msg;  // messaggio proveniente dal client
                    // spedizione della stringa dal server al client
                    i++;
                    dos.writeUTF("messaggio N."+i+" dal SERVER");

                    // legge il messaggio dal client
                    msg = dis.readUTF();
                    if (msg.equals("stop"))
                    {
                        System.out.println("il SERVER ha ricevuto lo STOP");
                        break;
                    }
                    System.out.println("il SERVER ha ricevuto il -> " + msg);
                } //while

                // chiusura della la connessione
                dos.close();
                dis.close();
                s.close();  // chiude la connessione
            }
            catch (IOException e)
            {
                i--;
            }
        } //while
    } //[m][s] main

} //{c} ServerTCP
