package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * LocArrSetElem.java
 * implementa Locator per un Set su array -
 * derivata da LocArrElem della v 1.x 
 *
 * @version 2.00 00/09/29
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidLocatorException;
import FI2.Util.SimpleComparable;

/**{c}
 * associa ad un oggetto il contenitore e un indice di 
 * posizione per identificarne l'inserimento nell'array
 * che fa da supporto alla realizzazione del contenitore
 */
public class LocArrSetElem implements Locator, SimpleComparable
{
    private Object elem;  // elemento
    private Container cont;  // contenitore
    private int pos;  // indice nell'array

    /**[c]
     * costruttore base
     * @param e  oggetto
     * @param c  contenitore
     * @param p  posizionatore
     */
    protected LocArrSetElem (Object e, Container c, int p) 
    {
        elem = e;
        cont = c;
        pos = p;
    } //[c] LocArrSetElem

    /**[m]
     * @see Locator
     */
    public Object element() 
      throws InvalidLocatorException
    { return elem; }

    /**[m]
     * @see Locator
     */
    public Object key() 
      throws InvalidLocatorException
    { return null; }

    /**[m]
     * @see Locator
     */
    public boolean isContained() 
      throws InvalidLocatorException 
    { return cont != null; }

    /**[m]
     * @see Locator
     */
    public Container container() 
      throws InvalidLocatorException 
    { 
        if (cont==null)
            throw new InvalidLocatorException(
              "Contenitore nullo");
        return cont; 
    } //[m] container

    /**[m]
     * @see SimpleComparable
     */
    public boolean equals(Object snd)
    { return elem.equals(((LocArrSetElem)snd).elem); }

    /**[m]
     * l'indice di posizione associato
     * @return posizione associata
     */
    protected int position() 
    { return pos; }

    /**[m]
     * imposta l'indice di posizione associato
     * @param p  posizione da assegnare
     */
    protected void setPosition(int p) 
    { pos = p; }

    /**[m]
     * imposta il contenitore associato
     * @param c  contenitore da assegnare
     */
    protected void setContainer(Container c) 
    { cont = c; }

} //{c} LocArrSetElem
