package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * LocatorSet.java
 * interfaccia che estende Set per
 * supportare Locator -
 * derivata da LocSet della v 1.x 
 *
 * @version 2.00 00/09/29
 * @author M.Moro DEI UPD
 */

import FI2.Set.LocatorIterator;
import FI2.Exceptions.InvalidElementException;
import FI2.Exceptions.InvalidLocatorException;

/**{i}
 * estende Set con metodi che supportano Locator
 * @see Set
 */
public interface LocatorSet extends Set
{
    /**[m][a]
     * aggiunge un elemento all'insieme
     * controllando che non vi appartenga gia` e
     * ne restituisce un riferimento (Locator) -
     * qualche realizzazione puo` sollevare
     * un'eccezione di tipo "full" -
     * @param obj  oggetto da aggiungere
     * @return riferimento all'oggetto inserito
     * @exception InvalidElementException
     * se l'elemento e` gia` presente
     */
    Locator insert(Object obj)
      throws InvalidElementException;

    /**[m][a] !!
     * aggiunge all'insieme un elemento 
     * fornito mediante riferimento
     * (per esempio perche' rimosso da un altro
     * insieme) -
     * qualche realizzazione puo` sollevare
     * un'eccezione di tipo "full" -
     * @param loc  riferimento all'oggetto da aggiungere
     * @return riferimento all'oggetto inserito
     * @exception InvalidLocatorException
     * se il riferimento e` illegale
     * @exception InvalidElementException
     * se l'elemento e` gia` presente
     */
    Locator insert(Locator loc)
      throws InvalidLocatorException, InvalidElementException;

    /**[m][a]
     * rimuove dall'insieme l'elemento
     * 'indicato' dal riferimento fornito
     * @param loc  riferimento all'oggetto da rimuovere
     * @exception InvalidLocatorException
     * se il riferimento e` illegale
     */
    void remove(Locator loc)
      throws InvalidLocatorException;

    /**[m][a]
     * restituisce una enumerazioni di riferimenti
     * agli elementi presenti
     * @return una enumerazione di riferimenti
     */
    LocatorIterator locators();

} //{i} LocatorSet
