package FI2.Sorting;
/**{p}
 * -- FI2.Sorting --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Ordinamento
 */

/**{f}
 * SeqBubbleSort.java
 * Applicazione di bubblesort a sequenze
 *
 * @version 2.00 00/09/20
 * @author M.Moro DEI UPD
 */

import java.io.*;
import FI2.Set.ObjectIterator;
import FI2.Set.Position;
import FI2.Linear.Vector;
import FI2.Linear.ArrayVector;
import FI2.Linear.List;
import FI2.Linear.ArrayList;
import FI2.Util.FI2Sys;
import FI2.Util.Metrics;

/**{c}
 * due versioni di bubble sort, una su ranked sequence e
 * una su positional sequence
 * @see ArrayVector
 * @see ArrayList
 * @see Metrics
 */
public class SeqBubbleSort
{

    /**[m][s]
     * bubble sort su Ranked Sequence -
     * O(n**2) se implementato con array -
     * O(n**3) se implementato con Deque
     * @param s  sequenza su cui opera
     */
    public static void bubbleSort1(Vector s)
    {
        int n = s.size();
        Metrics met = new Metrics();

        FI2Sys.out.println(
          "bubbleSort1 Seq. non ordinata [size=" 
          + n + "]: ");
        int vis = Math.min(10, Math.max(n, n/10));
        for (int i=0; i<vis; i++)
            FI2Sys.out.println(i + ": " + s.elemAtRank(i));
        if (n-vis > vis-1)
            for (int i=n-vis; i<n; i++)
                FI2Sys.out.println(i + ": " + 
                  s.elemAtRank(i));
        met.init();

        for (int i=0; i<n; i++)
            for (int j=0; j<n-i-1; j++)
            {
                met.cmpCnt++;
                  // metrica di confronto
                if ( ((Integer)s.elemAtRank(j)).intValue() >
                  ((Integer)s.elemAtRank(j+1)).intValue())
                {
                    Object tmp = s.elemAtRank(j);
                    s.replaceAtRank(j, s.elemAtRank(j+1));
                    s.replaceAtRank(j+1, tmp);
                    met.swapCnt++;
                      // metrica di scambio 
                } //if
            } //for j
        met.end();

        FI2Sys.out.println("bubbleSort1 Seq. ordinata [size=" 
          + n + "]: ");
        for (int i=0; i<vis; i++)
            FI2Sys.out.println(i + ": " + s.elemAtRank(i));
        if (n-vis > vis-1)
            for (int i=n-vis; i<n; i++)
                FI2Sys.out.println(i + ": " + 
                  s.elemAtRank(i));
        FI2Sys.out.println("bubbleSort1 Metriche:" + met);
    } //[m][s] bubbleSort1

    /**[m][s]
     * bubble sort su List -
     * O(n**2) in ogni caso
     * @param s  sequenza su cui opera
     */
    public static void bubbleSort2(List s)
    {
        int n = s.size();
        Metrics met = new Metrics();
        Position prec, succ;

        FI2Sys.out.println("bubbleSort2 Seq. non ordinata:");
        ObjectIterator it = s.elements();
        int vis = Math.min(10, Math.max(n, n/10));
        for (int i=0; i<vis; i++)
            FI2Sys.out.println(i + ": " + it.nextObject());
        if (n-vis > vis-1)
        {
            for (int i=vis; i<n-vis; i++)
                it.nextObject();
            for (int i=n-vis; i<n; i++)
                FI2Sys.out.println(i + ": " + 
                  it.nextObject());
        }

        met.init();
        for (int i=0; i<n; i++)
        {
            prec = s.first();
            for (int j=0; j<n-i-1; j++)
            {
                succ = s.after(prec);
                met.cmpCnt++;
                  // metrica di confronto
                if (((Integer)(prec.element())).intValue() >
                  ((Integer)(succ.element())).intValue())
                {
                    s.swapElements(prec, succ);
                    met.swapCnt++;
                      // metrica di scambio                }
                }
                prec = succ;
            } // for j
        } //for i
        met.end();

        it = s.elements();
        FI2Sys.out.println("bubbleSort2 Seq. ordinata:");
        for (int i=0; i<vis; i++)
            FI2Sys.out.println(i + ": " + it.nextObject());
        if (n-vis > vis-1)
        {
            for (int i=vis; i<n-vis; i++)
                it.nextObject();
            for (int i=n-vis; i<n; i++)
                FI2Sys.out.println(i + ": " + 
                  it.nextObject());
        }
        FI2Sys.out.println("bubbleSort2 Metriche:" + met);
    } //[m][s] bubbleSort2

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  opzionale: metodo scelto
     * @param args[1]  opzionale: nome file di input
     * @exception IOException  se file non trovato
     */
    public static void main(String[] args)
      throws IOException
    {
        InputStream in;

        if (args.length == 0)
        {
            // default, stdin
            in = System.in;
            FI2Sys.out.println(
              "Battere il numero di elementi:");
        }
        else
            in = new FileInputStream(args[0]);

        /* StreamTokenizer(InputStream) e` un costruttore
        deprecato in JDK 1.1; viene sostituito inserendo
        uno StreamReader che converte la sequenza di byte in
        sequenza di caratteri */
        Reader re = new BufferedReader
      (new InputStreamReader(in));
        StreamTokenizer sIn = new StreamTokenizer(re);

        sIn.parseNumbers();

        sIn.nextToken();
        int len = (int)sIn.nval;
        FI2Sys.out.println("Numero elementi: " + len);
        ArrayVector avs = 
          new ArrayVector();
        ArrayList als = 
          new ArrayList();

        for(int i=0; i<len; )
        {
            if (args.length == 0)
                FI2Sys.out.println("Battere elemento "
                  + (i+1) + ":");
            sIn.nextToken();
            if (sIn.ttype == StreamTokenizer.TT_EOF)
                break;
            if (sIn.ttype == StreamTokenizer.TT_NUMBER)
            {
                avs.insertAtRank(i++, 
                  new Integer((int)sIn.nval));
                als.insertLast(new Integer((int)sIn.nval));
            }
            else
                FI2Sys.out.println(sIn.sval +
                  " non numero: non inserito");
        } //for

        bubbleSort1(avs);
        bubbleSort2(als);
    } //[m][s] main

} //{c} SeqBubbleSort
