package FI2.Stream;
/**{p}
 * -- FI2.Stream --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Flussi
 */

/**{f}
 * Fcc.java
 * file compare ricorsivo
 *
 * @version 1.00 99/11/03
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * confronta due sottoalberi
 * segnalando su stdout i file diversi
 */
public class Fcc 
{

    /**[m][s]
     * confronta i contenuti di due file
     * @param f1  primo file
     * @param f2  secondo file
     * @exception IOException  errore IO
     */
    public static boolean fc(FileInputStream f1, 
      FileInputStream f2) throws IOException
    {
    byte buf1[] = new byte[512];
    byte buf2[] = new byte[512];
    int i1, i2;

        for(;;)
        {
        	i1 = f1.read(buf1);
        	i2 = f2.read(buf2);
        	if (i1 != i2)
    	    // differente lunghezza
        	    return false;
        	if (i1 == -1)
        	    // eguali
                return true;
        	for (int i=0; i<i1; i++)
        	    if (buf1[i] != buf2[i])
        	        return false;
        } //for
    } //[m][s] fc

    /**[m][s]
     * confronta due directory
     * @param path1  primo directory
     * @param path2  secondo directory
     * @exception IOException  errore I/O
     */
    public static void fcc(String path1, 
      String path2) throws IOException
    {
        File curDir1 = new File(path1, ".");
        File curDir2 = new File(path2, ".");

        System.out.println("^^ Confronto tra " + path1 + " e " + path2);

        String[] curDir1List = curDir1.list();
        if (curDir1List == null)
        {
            System.err.println("*** " + path1 + " non e` un directory!");
            System.exit(0);
        }

        for (int i=0; i<curDir1List.length; i++)
        {
            String fs1 = curDir1List[i];
            File ff1 = new File(path1, fs1);
            if (ff1.isDirectory())
                // subdirectory
                if (!fs1.equals(".") && !fs1.equals(".."))
                {
                    String pp1 = path1 + "/" + fs1;
                    String pp2 = path2 + "/" + fs1;
                    // giu` di un livello
                    fcc(pp1, pp2);
                    continue;
                }
                else
                    continue;
            // file ordinario
            FileInputStream f1 = new FileInputStream(ff1);
            FileInputStream f2;
            try
            {
                f2 = new FileInputStream(new File(path2, fs1));
            }
            catch (FileNotFoundException e)
            {
                System.out.println("**2* File " + path2 + "/" + fs1 + " non presente");
                System.err.println("**2* File " + path2 + "/" + fs1 + " non presente");
                continue;
            }
       
            System.err.println("Apre " + path1 + "/" + fs1 + " e " + path2 + "/" + fs1); 
            if (!fc(f1, f2))
            {
                System.out.println("**1* " + path1 + "/" + fs1 + " diverso da " +
                  path2 + "/" + fs1);
                System.err.println("**1* " + path1 + "/" + fs1 + " diverso da " +
                  path2 + "/" + fs1);
            }
        } //for
    } //[m][s] fcc

    /**[m][s]
     * main di attivazione
     * @param paths[0]  pathname del primo dir
     * @param paths[1]  pathname  del secondo dir
     * @exception IOException  errore I/O
     */
    public static void main (String[] paths) 
      throws IOException  
    {

        if (paths.length < 2)
            System.err.println("*** uso: Fcc {dirpath1} {dirpath2} >{outputfile}");
        else
            fcc(paths[0], paths[1]);
    } //[m][s] main

} //{c} Fcc
