package FI2.String;
/**{p}
 * -- FI2.String --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Stringhe
 */

/**{f}
 * Token.java
 * descrittore di token
 *
 * @version 1.00 99/12/13
 * @author M.Moro DEI UPD
 */

/**{c}
 * descrittore di token -
 * memorizza un lessema, una codifica di tipo
 * e una descrizione in chiaro del tipo,
 * una posizione di comparsa
 */
public class Token
{
    protected String lexem = null;
        // lessema 
    private int type;
        // codifica di tipo del token
    private String scode = null;
        // stringa che descrive il tipo
    private int row;  // riga di comparsa
    private int pos;  // posizione nella riga di comparsa

    /**[c]
     * costruttore base
     * @param s  stringa
     * @param t  codifica di tipo
     * @param d  descrizione
     * @param r  riga
     * @param p  posizione
     */
    public Token(String s, int t, String d, int r, int p)
    {
        lexem = s;
        type = t;
        scode = d;
        row = r;
        pos = p;
    } //[c] Token

    /**[m]
     * conversione a stringa del valore
     * @return lessema
     */
    public String toString()
    {  return lexem;  }

    /**[m]
     * conversione a descrizione estesa
     * @return stringa descrittiva
     */
    public String toString(int dummy)
    {
        return "<"+lexem+"> type="+type+" scode=<"+
          scode+"> row="+row+" pos="+pos;
    }

    /**[m]
     * tipo del token
     * @return tipo
     */
    public int type()
    {  return type; }

    /**[m]
     * descrizione tipo del token
     * @return descrizione tipo
     */
    public String typeDesc()
    {  return scode;  }

    /**[m]
     * la riga di comparsa
     * @return riga
     */
    public int row()
    {  return row;  }

    /**[m]
     * la posizione nella riga di comparsa
     * @return posizione (0..rowlen-1)
     */
    public int pos()
    {  return pos;  }

} //{c} Token
