package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * DAGManag.java
 * Ordinamento topologico di un DAG
 * prova scritta del 10/2/2001
 *
 * @version 1.00 01/01/12
 * @author M.Moro DEI UPD
 */

import java.io.*;
import java.text.NumberFormat;
import FI2.Linear.Stack;
import FI2.Linear.ArrayStack;
import FI2.Util.FI2Sys;

/**{c}
 * Topological Sort vedi [Good] pagg. 578-9
 */
public class DAGManag
{
    public static int[] topSort(boolean[][] graph) 
      throws NotAcyclicException
    {
        Stack s = new ArrayStack();
        int numv = graph.length;  // numero vertici (matrice quadrata)
        int incounter[] = new int[numv]; // grado d'input dei vertici
        int ret[] = new int[numv]; // vertici ordinati topologicamente

        // calcolo del grado d'ingresso dei vertici
        for(int col=0; col<numv; col++)
            // per calcolare il grado d'input del vertice col
            // si contano gli elementi true della colonna col
            for (int row=0; row<numv; row++)
                if (graph[row][col])
                    incounter[col]++;

// non richiesto                    
FI2Sys.out.println("Incounter iniziale:");
for(int i=0; i<numv; i++)
FI2Sys.out.println("inc[" + i + "] = " + incounter[i]);
// -------

        // inserimento iniziale nello stack
        // dei vertici di grado nullo
        for(int i=0; i<numv; i++)
            if (incounter[i] == 0)
                s.push(new Integer(i));
        
        int curr = 0;  
          // l'uscita da' i vertici in un vettore con indice iniziale 0
        
        while(!s.isEmpty())
        {
            int u = ((Integer)s.pop()).intValue();
// non richiesto            
FI2Sys.out.println("Estratto " + u);
// -------
            ret[curr++] = u;
            for(int col=0; col<numv; col++)
                if (graph[u][col])
                    // un arco (u, col)
                    if (--incounter[col] == 0)
                        // inserisce nello stack vertici
                        // 'raggiunti' esclusivamente da vertici
                        // precedenti
                        s.push(new Integer(col));
        } // while stack not empty
        
        if (curr < numv)
            // non tutti i vertici sono stati trattati =>
            // il grafo non e' aciclico
            throw new NotAcyclicException("Componente aciclica di " + 
              curr + " elementi"); 
        return ret;
    }

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  numero dati
     * @exception IOException  se file non trovato 
     */
    public static void main(String[] args)
      throws IOException
    {
        InputStream in;

        if (args.length == 0)
        {
            // default, stdin
            in = System.in;
            FI2Sys.out.println("DAGManag: Battere num. vertici:");
        }
        else
            in = new FileInputStream(args[0]);

        /* StreamTokenizer(InputStream) e` un costruttore
        deprecato in JDK 1.1; viene sostituito inserendo
        uno StreamReader che converte la sequenza di byte in
        sequenza di caratteri */
        Reader re = new BufferedReader(new
          InputStreamReader(in));
        StreamTokenizer sIn = new StreamTokenizer(re);
        int numv = 1;
        boolean graph[][] = null;

        sIn.parseNumbers();
        try
        {
            while(sIn.nextToken() != StreamTokenizer.TT_EOF)
            {
                if (sIn.ttype == StreamTokenizer.TT_NUMBER)
                {
                    numv = (int)sIn.nval;  // numero vertici
                    break;
                } //if
                else  
                    FI2Sys.out.println(sIn.sval +
                      " non numero vertici: ignorato");
            } //while
            
            graph = new boolean[numv][numv];  // inizializzato a false
            
            if (in == System.in)
            FI2Sys.out.println(
  "Battere archi (coppie vertici ordinate) (fine=Ctrl-Z)");
            while(sIn.nextToken() != StreamTokenizer.TT_EOF)
            {
                if (sIn.ttype == StreamTokenizer.TT_NUMBER)
                {
                    int row = (int)sIn.nval;
                    if (sIn.nextToken() == StreamTokenizer.TT_EOF)
                        // fine file, esce
                        break;
                    graph[row][(int)sIn.nval] = true; // imposta arco
                    FI2Sys.out.println("impostato arco (" + row + ", " 
                      + (int)sIn.nval +")");
                } //if
                else  
                    FI2Sys.out.println(sIn.sval +
                      " non numero: non inserito");
            } //while

        } //try
        catch (EOFException e)
        {
            // termina il ciclo
        } //catch(EOF)

        int sort[];
        try
        {
            sort = topSort(graph);
            FI2Sys.out.println("Ordinamento:");
            for (int i=0; i<numv; i++)
                FI2Sys.out.println(i + " -> " + sort[i]);
                
// 1^ alternativa
            // intestazione con la lista ordinata dei vertici
            NumberFormat nf = NumberFormat.getInstance();
            nf.setMinimumIntegerDigits(2);
            nf.setMaximumIntegerDigits(2);
            String str = "";
            for (int i=0; i<numv; i++)
                str += nf.format(sort[i]) + "  ";
            FI2Sys.out.println(str);
            
            // semigrafo
            for (int row=0; row<numv; row++)
            {
                str = "";
                for (int i=0; i<row; i++)
                    str += "    ";
                for(int col=row; col<numv; col++)
                {
                    if (graph[sort[row]][sort[col]])
                    {
                        str += "*";
                        for(int j=row; j<col-1; j++)
                            str += "---|";
                        str += "-->+";
                        for(int j=col+1; j<numv; j++)
                            str += "   |";
                        FI2Sys.out.println(str);
                        str = "";
                        for (int i=0; i<row; i++)
                            str += "    ";
                    } // if
                } // for col
            } // for row
            
// 2^ alternativa            
            for (int i=0; i<numv; i++)
                FI2Sys.out.println(i + " -> " + sort[i]);

            int riord[] = new int[numv];
            for (int i=0; i<numv; i++)
                riord[sort[i]] = i;
            FI2Sys.out.println("Vertici riordinati");
            for (int i=0; i<numv; i++)
                FI2Sys.out.println(i + " -> " + riord[i]);
            FI2Sys.out.println("Archi riordinati");
            for (int row=0; row<numv; row++)
                for (int col=0; col<numv; col++)
                    if (graph[sort[row]][sort[col]])
                        FI2Sys.out.println("(" + 
                          riord[sort[row]] + ", " +
                          riord[sort[col]] + ") ");
        }
        catch (NotAcyclicException e)
        {
            FI2Sys.out.println(e);
        }

    } //[m][s] main

} //{c} DAGManag

