package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * FuncNormato.java
 * Prima prova intermedia 2000/2001
 * Tema a
 *
 * @version 1.00 00/10/04
 * @author M.Moro DEI UPD
 */

// non richiesta
class MyFunc1 implements FuncDesc
{
    public int f(int x)
    {
        return (int)(40*(Math.sin(Math.PI * (double)x / 50.0)));
    }
} //{c} MyFunc1

// non richiesta
class MyFunc2 implements FuncDesc
{
    public int f(int x)
    {
        return (((int)Math.abs(x%20)) < 10) ? -3 : 3;
    }
} //{c} MyFunc2

public class FuncNormato extends NormaBase 
implements Normato
{
    private FuncDesc fdesc;
    private double valNorma;
    private static int MIN = 0;  // indici min-max
    private static int MAX = 1;

    /**[m]
     * calcolo del minimo e del massimo
     * @param mM  array 2 componenti dove viene collocata
     *            la coppia minimo - massimo
     */
    private void minmax(int mM[])
    {
        mM[MAX] = Integer.MIN_VALUE;
        mM[MIN] = Integer.MAX_VALUE;
        for (int i=0; i<=100; i++)
        {
            int ret = fdesc.f(i);
            if (ret < mM[MIN])
                mM[MIN] = ret;
            if (ret > mM[MAX])
                mM[MAX] = ret;
        }
    }
        
    /**[c]
     * costruttore base
     * @param fd  descrittore di funzione
     */
    public FuncNormato(FuncDesc fd)
    {
        fdesc = fd;
        int mM[] = new int[2];
        minmax(mM);  // calcolo min-max
        valNorma = mM[MAX]-mM[MIN];
    }
    
    public String toString()
    {
        int mM[] = new int[2];
        minmax(mM);  // calcolo min-max
        return "min=" + mM[MIN] + " max=" + mM[MAX] +
          " norma=" + valNorma;
    }
    
    public boolean equals(Object altro)
    {
        return fdesc.equals(((FuncNormato)altro).fdesc);
    }
    
    public double norma()
    {
        return valNorma;
    }
    
    public Normato diff(Normato altro)
    {
        return new FuncNormato(new 
          DiffFunc(fdesc, ((FuncNormato)altro).fdesc));
    }
    
    // non richiesto 
    public static void main(String[] args)
    {
        Normato f1 = new FuncNormato(new MyFunc1());
        Normato f2 = new FuncNormato(new MyFunc2());
        System.out.println("f1=" + f1);
        System.out.println("||f1||=" + f1.norma());
        System.out.println("||f1|| Double=" + f1.norma(0));
        System.out.println("||f1||==0 " + f1.seNormaZero());
        System.out.println("f2=" + f2);
        System.out.println("||f2||=" + f2.norma());
        System.out.println("||f2|| Double=" + f2.norma(0));
        System.out.println("||f2||==0 " + f2.seNormaZero());
        Normato d = f1.diff(f2);
        System.out.println("f1-f2=" + d);
        System.out.println("distanza=" + f1.distanza(f2));
        System.out.println("f1 " + 
        ((((FuncNormato)f1).equals(f2)) ? "e`" : "non e`") +
        " eguale a f2");
        
    } //[m][s] main
  
    
} //{c}{a} FuncNormato

