package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * MMS.java
 * Scritto del 6/2/99
 *
 * @version 1.00
 * @author M.Moro DEI UPD
 */

import FI2.Linear.*;
import FI2.Util.*;

public class MMS
{

    /**[m][s]
     * metodo di supporto: fonde gruppi di 2**factor
     * elementi in q1 in gruppi ordinati di 
     * 2**(factor+1) elementi
     * @param q1  coda da ordinare con gruppi 
     *            ordinati di 2**factor elementi
     * @param q2  coda di supporto, assunta vuota
     * @param q3  coda di supporto, assunta vuota
     * @param factor  fattore per i gruppi
     * @param comp  comparatore
     */
    public static void fmerge(Queue q1, Queue q2, 
      Queue q3, int factor, Comparator comp)
    {
        int group = (1 << factor); // 2**factor

        // prima fase, trasferisce da q1 
        // alternativamente su q2 e q3 i gruppi 
        while(!q1.isEmpty())
        {
            for (int i=0; i<group && !q1.isEmpty(); 
              i++)
                q2.enqueue(q1.dequeue());
            for (int i=0; i<group && !q1.isEmpty(); 
              i++)
                q3.enqueue(q1.dequeue());
        } //while

        // seconda fase, merge per gruppi
        while (!q2.isEmpty() && !q3.isEmpty())
        {
            int iq2 = group, iq3 = group;

            while (iq2!=0 && !q2.isEmpty() && 
              iq3!=0 && !q3.isEmpty())
            {
                if (comp.isLessThanOrEqualTo(
                  q2.front(), q3.front()))
                {
                    // il minore e` in q2
                    q1.enqueue(q2.dequeue());
                    iq2--;
                }
                else
                {
                    // il minore e` in q3
                    q1.enqueue(q3.dequeue());
                    iq3--;
                }
            } // while iq2, iq3

            // rimanenze di gruppo
            // se un gruppo e' incompleto, 
            // l'altra coda e' vuota
            while (iq2-- !=0 && !q2.isEmpty())
                q1.enqueue(q2.dequeue());
            while (iq3-- !=0 && !q3.isEmpty())
                q1.enqueue(q3.dequeue());
        } //while q2, q3
        // rimanenze di coda, una delle due e` gia` vuota
        while (!q2.isEmpty())
            q1.enqueue(q2.dequeue());
        while (!q3.isEmpty())
            q1.enqueue(q3.dequeue());
    }//[m][s] fmerge

    /**[m][s]
     * metodo di sorting
     * @param q  coda da ordinare
     * @param comp  comparatore
     */
    public static void fmsort(Queue q, Comparator comp)
    {
        // code di supporto;
        // q potrebbe anche non essere implementata
        // come LinkedQueue
        Queue q2 = new LinkedQueue();
        Queue q3 = new LinkedQueue();

        int k = 0, group=1, n = q.size();
     
        while (group < n)
        {
            k++;
            group <<=1; // * 2
        }
        // 2**(k-1) < n, 2**k >= n
        for (int factor=0; factor <k; factor++)
        {
            fmerge(q, q2, q3, factor, comp);
        }
    } //[m][s] fmsort

} //{c} MMS


