package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * MMSArrQue.java
 * Scritto del 6/2/99
 *
 * @version 1.00
 * @author M.Moro DEI UPD
 */

import java.io.*;
import FI2.Linear.*;
import FI2.Exceptions.*;
import FI2.Util.*;

/**{c}
 * estende ArrayQueue con sort
 */
public class MMSArrQue extends ArrayQueue
{
    private Comparator c;  // comparatore per il confronto

    /**[c]
     * costruttore di default
     * @param comp  comparatore per il confronto
     */
    public MMSArrQue(Comparator comp)
    {
        super();
        c = comp;
    } //[c] MMSArrQue

    /**[c]
     * costruttore con capacita` massima
     * in numero di elementi
     * @param cap  capacita` massima dell'array
     * @param comp  comparatore per il confronto
     */
    public MMSArrQue(int cap, Comparator comp)
    {
        super(cap);
        c = comp;
    } //[c] MMSArrQue

    /**[m]
     * metodo di sort
     */
    public void sort()
    {
        MMS.fmsort(this, c);
    } //[m] sort

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  opzionale: nome file di input
     * @exception IOException  se file non trovato 
     */
    public static void main(String[] args)
      throws IOException
    {
        InputStream in;

        if (args.length == 0)
        {
            // default, stdin
            in = System.in;
            FI2Sys.out.println(
  "MMSArrQue: Battere almeno 6 interi (fine=Ctrl-Z):");
        }
        else
            in = new FileInputStream(args[0]);

        /* StreamTokenizer(InputStream) e` un costruttore
        deprecato in JDK 1.1; viene sostituito inserendo
        uno StreamReader che converte la sequenza di byte in
        sequenza di caratteri */
        Reader re = new BufferedReader(new
          InputStreamReader(in));
        StreamTokenizer sIn = new StreamTokenizer(re);
        MMSArrQue myQueue = new MMSArrQue(101, new IntegerComparator());

        sIn.parseNumbers();
        try
        {
            Integer next;
            int pos = 0;

            while(sIn.nextToken() != StreamTokenizer.TT_EOF)
            {
                if (sIn.ttype == StreamTokenizer.TT_NUMBER)
                {
                    next = new Integer((int)sIn.nval);
                    myQueue.enqueue(next);
                } //if
                else  
                    FI2Sys.out.println(sIn.sval +
                      " non numero: non inserito");
            } //while

        }
        catch (EOFException e)
        {
            // termina il ciclo
        } //catch(EOF)
        catch (QueueFullException e)
        {
            FI2Sys.out.println("[" + e + "] troppi numeri!");
            // termina il ciclo
        } //catch(QueueFullException)
        // la lista ha ora i numeri forniti nell'ordine

        FI2Sys.out.println("Coda creata");
        FI2Sys.out.println(myQueue);

        FI2Sys.out.println("size=" + myQueue.size());

        myQueue.sort();
        FI2Sys.out.println("Coda ordinata");
        FI2Sys.out.println(myQueue);
    } //[m] main

} //{c} MMSArrQue
