package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * PQueue.java
 * Scritto del 6/9/99
 *
 * @version 1.00
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.QueueEmptyException;
import FI2.Exceptions.BoundaryViolationException;
import FI2.Linear.Queue;

/**{i}
 * coda con inserimento in posizione
 * @see Queue
 */
public interface PQueue extends Queue
{

    /**[m][a]
     * oggetto in fondo alla coda FIFO -
     * viene sollevata l'eccezione
     * QueueEmptyException in caso di coda FIFO vuota
     * @return  l'oggetto se la coda FIFO non e` vuota
     * @exception QueueEmptyException  coda FIFO vuota
     */
    Object rear() throws QueueEmptyException;

    /**[m][a]
     * inserisce un elemento in posizione relativa -
     * se pos<=0 il nuovo elemento occupera` la posizione
     * -pos dal fondo;
     * se pos>0 il nuovo elemento occupera` la posizione
     * pos-1 dalla testa -
     * viene sollevata l'eccezione
     * BoundaryViolationException se la posizione supera 
     * gli estremi -
     * qualche realizzazione puo` sollevare l'eccezione
     * QueueFullException
     * @param element  oggetto da inserire
     * @param pos  posizione relativa
     * @exception BoundaryViolationException  
     * posizione oltre gli estremi
     */
    void insert(Object element, int pos)
      throws BoundaryViolationException;

} //{i} PQueue
