package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * Route.java
 * Prima prova intermedia 1999/2000 
 *
 * @version 1.00 99/11/07
 * @author M.Moro DEI UPD
 */

import FI2.Util.*;
import java.util.Enumeration;
import java.util.NoSuchElementException;

class FullArrayException extends RuntimeException // non richiesta esplicitamente
{  
    public FullArrayException(String err) 
    {
        super("Array pieno: " + err);
    }
}

public class Route implements EnumerableContainer
{
    private GeoPoint[] rou;
    private int sz = 0;

    public Route(int cap)
    {
        rou = new GeoPoint[cap];
    }

    public int size() { return sz; }

    public boolean isEmpty() { return sz == 0; }

    public Enumeration elems(final Object select)
    {

        return new Enumeration()
        {  // classe anonima
            private boolean fd;  // forward
            private int curr;

            { // costruttore
                if (fd = ((Boolean)select).booleanValue())
                    curr = 0;  // avanti
                else
                    curr = sz-1;
            }

            public boolean hasMoreElements()
            {
                if (fd)
                    return curr < sz;
                return curr >=0;
            }

            public Object nextElement()
            {
                if (! hasMoreElements())
                    throw new NoSuchElementException(
"In Route.Enumeration.nextElement: fine elementi [curr="
                  + curr + "]");
                if (fd)
                    return rou[curr++];
                return rou[curr--];
            }
        } // Enumeration
        ;
    }

    public void insert(GeoPoint p)
      throws FullArrayException
    {
        if (sz == rou.length)
            throw new FullArrayException("size="+sz);
        rou[sz++] = p;
    }

    public String toString() // non richiesto
    {
        Enumeration en = elems(new Boolean(true));
        String str = "Route:";
        while (en.hasMoreElements())
        {
            str += " " + en.nextElement();
        }
        return str;
    }

    public static void main(String[] args)
      // non richiesto
    {
        Route rou = new Route(5);

        try
        {
            rou.insert(new GeoPoint(7, 41, 'w', 12, 13, 's'));
            rou.insert(new GeoPoint(12, 24, 'w', 26, 7, 'n'));
            rou.insert(new GeoPoint(1, 1, 'e', 1, 1, 'n'));
            rou.insert(new GeoPoint(1, 1, 'w', 1, 1, 's'));
            rou.insert(new GeoPoint(10, 10, 'w', 10, 10, 'n'));
            rou.insert(new GeoPoint(1, 2, 'w', 3, 4, 's'));
        }
        catch (Exception e)
        {
            // ignora
            FI2Sys.out.println(e);
        }

        FI2Sys.out.println(rou);
        Enumeration en = rou.elems(new Boolean(false));
        GeoPoint prec = null, succ=null;
        int[] dist;

        while (en.hasMoreElements())
        {
            succ = (GeoPoint)en.nextElement();
            if (prec != null)
            {
                dist = prec.dist(succ);
                FI2Sys.out.println("curr="+succ+" dist W-E="+dist[0]+" N-S="+dist[1]);
            }
            else
                FI2Sys.out.println("curr="+succ);
            prec = succ;
        }
    } // main
} // Route
