package FI2.Tree;
/**{p}
 * -- FI2.Tree --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Alberi
 */

/**{f}
 * Eulertour.java
 * template per attraversamento 
 * ricorsivo binario -
 * derivata da BinaryTreeTraversal della v 1.x
 *
 * @version 3.00 00/09/22
 * @author M.Moro DEI UPD
 */

import FI2.Set.Position;

/**{c}
 * template per attraversamento generico mediante tour di
 * Eulero di un albero binario -
 * i metodi non definiti vanno specializzati in una classe
 * derivata
 * @see InspectableBinaryTree
 */
public abstract class EulerTour 
{
    protected InspectableBinaryTree tree; 

    /**[m]
     * metodo generico di esecuzione dell'algoritmo 
     * di interesse -
     * questa versione e` poco piu` che un dummy
     * @param T  albero su cui si opera
     * @return un oggetto-risultato se previsto
     */
    public Object execute(InspectableBinaryTree T) 
    {
        tree = T;
        return null;
    } //[m] execute

    /**[m]
     * attraversamento ricorsivo
     * @param p  posizione di partenza
     * @return un oggetto-risultato se previsto
     */
    protected Object eulerTour(Position p) 
    {
        TraversalResult r = initResult();
          // fase iniziale
        if (tree.isExternal(p))
            // nodo esterno
            visitExternal(p, r);
        else {
            // nodo interno
            visitLeft(p, r);  
              // sta per andare a sinistra
            r.leftResult = 
              eulerTour(tree.leftChild(p)); 
              // chiamata ricorsiva a sinistra
            visitBelow(p, r); 
              // ritorna qui e sta per andare a destra
            r.rightResult = 
              eulerTour(tree.rightChild(p));
              // chiamata ricorsiva a destra
            visitRight(p, r);
              // torna qui dopo essere andato a destra
        } //else
        return result(r);  // genera risultato finale
    } //[m] eulerTour

    // seguono metodi da ridefinire nelle classi
    // derivate di specializzazione

    /**[m]
     * trattamento di nodo esterno
     * @param p  posizione del nodo 
     * @param r  risultato iniziale
     */
    protected void visitExternal(Position p, TraversalResult r) {}

    /**[m]
     * trattamento che precede la chiamata a sinistra
     * @param p  posizione del nodo padre
     * @param r  risultato iniziale
     */
    protected void visitLeft(Position p, TraversalResult r) {}

    /**[m]
     * trattamento che precede la chiamata a destra
     * @param p  posizione del nodo padre
     * @param r  risultato iniziale
     */
    protected void visitBelow(Position p, TraversalResult r) {}

    /**[m]
     * trattamento che segue la chiamata a destra
     * @param p  posizione del nodo padre
     * @param r  risultato iniziale
     */
    protected void visitRight(Position p, TraversalResult r) {}

    /**[m]
     * generazione del risultato iniziale
     * @return un risultato iniziale
     */
    protected TraversalResult initResult() 
    { return new TraversalResult(); }

    /**[m]
     * generazione del risultato finale
     * @return un oggetto-risultato
     */
    protected Object result(TraversalResult r) 
    { return r.finalResult; }

} //{c} EulerTour
