package FI2.Tree;
/**{p}
 * -- FI2.Tree --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Alberi
 */

/**{f}
 * InspectableBinaryTree.java
 * albero binario con metodi read-only -
 * derivata da BinaryTree della v 1.x
 *
 * @version 3.00 00/09/22
 * @author M.Moro DEI UPD
 */

import FI2.Set.Position;
import FI2.Set.PositionIterator;
import FI2.Exceptions.InvalidPositionException;
import FI2.Exceptions.InvalidContainerException;
import FI2.Exceptions.BoundaryViolationException;

/**{i}
 * albero binario con metodi a sola lettura -
 * estende l'albero generico con alcuni metodi
 * @see InspectableBinaryTree
 */
public interface InspectableBinaryTree 
  extends InspectableTree
{
    /**[m][a]
     * il nodo figlio di sinistra di un nodo dell'albero
     * @param v  nodo di cui restituire il figlio
     * @return nodo figlio di sinistra di v
     * @exception BoundaryViolationException
     * v e` foglia dell'albero contenitore
     * @exception InvalidPositionException
     * posizionatore illegale
     * @exception InvalidContainerException
     * contenitore this illegale
     */
    Position leftChild(Position v)
      throws BoundaryViolationException, 
      InvalidPositionException, InvalidContainerException;

    /**[m][a]
     * il nodo figlio di destra di un nodo dell'albero
     * @param v  nodo di cui restituire il figlio
     * @return nodo figlio di destra di v
     * @exception BoundaryViolationException
     * v e` foglia dell'albero contenitore
     * @exception InvalidPositionException
     * posizionatore illegale
     * @exception InvalidContainerException
     * contenitore this illegale
     */
    Position rightChild(Position v)
      throws BoundaryViolationException, 
      InvalidPositionException, InvalidContainerException;

    /**[m][a]
     * il nodo fratello del nodo di un nodo dell'albero
     * @param v  nodo di cui restituire il fratello
     * @return nodo fratello di v
     * @exception BoundaryViolationException
     * v e` radice dell'albero contenitore
     * @exception InvalidPositionException
     * posizionatore illegale
     * @exception InvalidContainerException
     * contenitore this illegale
     */
    Position sibling(Position v)
      throws BoundaryViolationException, 
      InvalidPositionException, InvalidContainerException;

} //{i} InspectableBinaryTree
