package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * Equality.java
 * interfaccia per confronti di eguaglianza
 *
 * @version 1.00 98/09/14
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidElementException;

/**{i}
 * consente la possibilita` di confronti di eguaglianza
 * tra oggetti generici, non inclusi - questo consente che
 * una coppia di oggetti esterni possa essere confrontata in
 * modi anche diversi
 */
public interface Equality
{
    /**[m][a]
     * confronto di eguaglianza
     * @param a  primo oggetto da confrontare
     * @param b  secondo oggetto da confrontare
     * @return true se a==b,
     *         false altrimenti
     * @exception InvalidElementException 
     * se oggetti non comparabili
     */
    boolean isEqualTo (Object a, Object b)
      throws InvalidElementException;

    /**[m][a]
     * comparabilita` di un oggetto
     * @param a  l'oggetto
     * @return true se this e` applicabile all'oggetto come
     * comparatore, 
     *         false altrimenti
     */
    boolean isComparable (Object a);

} //{i} Equality
