package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * FI2RS.java
 * supporto di input
 *
 * @version 1.00 99/10/22
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * aggiunge a Reader alcune funzioni di utilita` -
 * ricavata dalla classe Console di corejava [Hor]
 * @see InputStreamReader
 */
public class FI2RS extends InputStreamReader
{

    /**[c]
     * costruttore base
     * @param in  stream di input
     */
    public FI2RS(InputStream in)
    {
        super(in);
    } //[c] FI2R
    

    
    /**[m]
     * output di stringa di prompt
     * @param prompt  stringa di prompt
     */
    public static void prompt(String pr)
    {
        FI2Sys.out.print(pr + " ");
        FI2Sys.out.flush();
    } //[m] prompt

    /**[m]
     * lettura di una linea + prompt
     * @param prompt  stringa di prompt
     * @return la linea letta
     */
    public String readLine(String pr)
    {  
        prompt(pr);
        return readLine();
    }

    /**[m]
     * lettura di una linea
     * @return la linea letta
     */
    public String readLine()
    {  
        int ch;
        String r = "";
        boolean done = false;

        while (!done)
        {  
            try
            {  
                ch = read();
                if (ch < 0 || (char)ch == '\n')
                    done = true;
                else if ((char)ch != '\r')
                    r = r + (char) ch;
            }
            catch(java.io.IOException e)
            {  
                done = true;
            }
      } // while
      return r;
   } //[m] readLine
    
    /**[m]
     * acquisizione di un valore intero
     * @param prompt  stringa di prompt
     * @return intero acquisito
     * @exception NumberFormatException
     * se la linea non rappresenta un intero
     */
    public int readInt(String pr)
      throws NumberFormatException
    {  
        prompt(pr);
        return Integer.valueOf
          (readLine().trim()).intValue();
    } //[m] readInt

    /**[m]
     * acquisizione di un valore double
     * @param prompt  stringa di prompt
     * @return double acquisito
     * @exception NumberFormatException
     * se la linea non rappresenta un double
     */
    public double readDouble(String pr)
      throws NumberFormatException
    {  
        prompt(pr);
        return Double.valueOf
          (readLine().trim()).doubleValue();
    } //[m] readInt

} //{c} FI2RS


