package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * IntegerComparator.java
 * comparatore per interi
 *
 * @version 2.00 98/08/15
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidElementException;

/**{c}
 * implementa Comparator per confrontare chiavi
 * Integer secondo il normale ordinamento
 * @see Comparator
 */
public class IntegerComparator implements Comparator 
{
    /**[c]
     * costruttore di default nullo
     */
    public IntegerComparator(){}
    
    /**[m]
     * @see Equality
     */
    public boolean isEqualTo(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2);
        return integer(x1)==integer(x2);    
    } //[m] isEqualTo

    /**[m]
     * @see Comparator
     */
    public boolean isGreaterThan(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2); 
        return integer(x1)>integer(x2);
    } //[m] isGreaterThan
    
    /**[m]
     * @see Comparator
     */
    public boolean isLessThan(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2);
        return integer(x1)<integer(x2);
    } //[m] isLessThan
    
    /**[m]
     * @see Comparator
     */
    public boolean 
      isGreaterThanOrEqualTo(Object x1, Object x2)
      throws InvalidElementException
    {
        check(x1,x2);
        return integer(x1)>=integer(x2);    
    } //[m] isGreaterThanOrEqualTo
    
    /**[m]
     * @see Comparator
     */
    public boolean isLessThanOrEqualTo(Object x1, Object x2)
        throws InvalidElementException
    {
        check(x1,x2);
        return integer(x1)<=integer(x2);    
    } //[m] isLessThanOrEqualTo

    /**[m]
     * @see Equality
     */
    public boolean isComparable(Object x)
    {
        if (x==null)
            return false;
        try{
            integer(x);
            return true;
        }
        catch (InvalidElementException iee){
            return false;
        }
    } //[m] isComparable

    // metodi di supporto

    /*[m]
     * verifica se entrambi gli oggetti sono nonnulli
     * @param x1  primo oggetto
     * @param x2  secondo oggetto
     * @exception InvalidElementException
     * se uno o entrambi gli oggetti nulli
     */
    private void check(Object x1, Object x2) 
      throws InvalidElementException 
    {
        if ((x1==null) || (x2==null)) throw
           new InvalidElementException(
           "Comparatore applicato ad oggetto nullo");
    } //[m] check

    /*[m]
     * conversione di oggetto Integer a intero
     * @param x  oggetto
     * @return intero corrispondente
     * @exception InvalidElementException
     * se oggetto non Integer
     */
    private int integer(Object x) 
      throws InvalidElementException 
    {
        try
        {
            return ((Integer)x).intValue();
        }
        catch (ClassCastException e){
            throw new 
            InvalidElementException("Oggetto non Integer");
        } //try-catch
    } //[m] integer

} //{c} IntegerComparator
