package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * StringComparator.java
 * comparatore per String
 *
 * @version 2.00 98/09/26
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidElementException;

/**{c}
 * implementa Comparator per confrontare chiavi
 * che sono String di lunghezza arbitraria
 * secondo il normale ordinamento lessicografico
 * @see Comparator
 */
public class StringComparator implements Comparator 
{
    /**[c]
     * costruttore di default nullo
     */
    public StringComparator(){}
    
    /**[m]
     * @see Equality
     */
    public boolean isEqualTo(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2);
        return ((String)x1)
          .compareTo((String)x2) == 0;  
    } //[m] isEqualTo

    /**[m]
     * @see Comparator
     */
    public boolean isGreaterThan(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2); 
        return ((String)x1)
          .compareTo((String)x2) > 0;   
    } //[m] isGreaterThan
    
    /**[m]
     * @see Comparator
     */
    public boolean isLessThan(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2);
        return ((String)x1)
          .compareTo((String)x2) < 0;   
    } //[m] isLessThan
    
    /**[m]
     * @see Comparator
     */
    public boolean 
      isGreaterThanOrEqualTo(Object x1, Object x2)
      throws InvalidElementException
    {
        check(x1,x2);
        return ((String)x1)
          .compareTo((String)x2) >= 0;  
    } //[m] isGreaterThanOrEqualTo
    
    /**[m]
     * @see Comparator
     */
    public boolean isLessThanOrEqualTo(Object x1, Object x2)
        throws InvalidElementException
    {
        check(x1,x2);
        return ((String)x1)
          .compareTo((String)x2) <= 0;  
    } //[m] isLessThanOrEqualTo

    /**[m]
     * @see Equality
     */
    public boolean isComparable(Object x)
    {
        if (x==null)
            return false;
        try
        {
            String tmp = (String)x;
            return true;
        }
        catch (ClassCastException e)
        {
            return false;
        }
    } //[m] isComparable

    // metodi di supporto

    /*[m]
     * verifica se entrambi gli oggetti sono nonnulli
     * @param x1  primo oggetto
     * @param x2  secondo oggetto
     * @exception InvalidElementException
     * se uno o entrambi gli oggetti nulli
     */
    private void check(Object x1, Object x2) 
      throws InvalidElementException 
    {
        if ((x1==null) || (x2==null)) throw
           new InvalidElementException(
           "Comparatore applicato ad oggetto nullo");
        try
        {
            String tmp = (String)x1;
        }
        catch (ClassCastException e)
        {
            throw new 
              InvalidElementException("Oggetto <" + 
              x1 + "> non String");
        }
        try
        {
            String tmp = (String)x2;
        }
        catch (ClassCastException e)
        {
            throw new 
              InvalidElementException("Oggetto <" + 
              x2 + "> non String");
        }
    } //[m] check

    /*[m]
     * conversione di oggetto String a intero
     * per il confronto
     * @param x  oggetto
     * @return intero corrispondente
     * @exception InvalidElementException
     * se oggetto non Integer
     */
    private int integer(Object x) 
      throws InvalidElementException 
    {
        try
        {
            return ((Integer)x).intValue();
        }
        catch (ClassCastException e){
            throw new 
            InvalidElementException("Oggetto non Integer");
        } //try-catch
    } //[m] integer

} //{c} StringComparator
