// FileProgramma.java -- gestione del file di un programma per Ram

import java.awt.event.*;
import java.awt.*;
import java.io.*;

class FileProgramma implements ActionListener {

  private FinestraRam finestra;
  private TextArea area;
  private String nomeDelFile;

  public FileProgramma (FinestraRam finestra, TextArea area) {
    this.finestra = finestra;
    this.area = area;
    }

  public void actionPerformed (ActionEvent evt) {
    String comando = evt.getActionCommand();
      if (comando.equals("leggi")) { 
      try {
        FileDialog dialogo = new FileDialog(finestra, "Apri", FileDialog.LOAD);
        dialogo.show();
        nomeDelFile = dialogo.getDirectory();
        nomeDelFile += dialogo.getFile();
        StringBuffer buf = new StringBuffer();
        String riga;
        BufferedReader in = new BufferedReader(new FileReader(nomeDelFile));
        while ((riga = in.readLine()) != null) {
          buf.append(riga);
          buf.append('\n');
          }
        area.setText(buf.toString());
        in.close();
        } catch (IOException e) {
          finestra.errori.add("Errore di I/O");
          }
      }          
    else if (comando.equals("scrivi")) {
      try {
        String str = area.getText();
        PrintWriter out = new PrintWriter(new FileOutputStream(nomeDelFile));
        for (int i = 0; i < str.length(); i++)
          if (str.charAt(i) == '\n')
            out.println();
          else
            out.print(str.charAt(i));
        out.close();
        } catch (IOException e) {
          finestra.errori.add("Errore di I/O");
          }
      }
    else if (comando.equals("nuovo")) {
      try {
        FileDialog dialogo = new FileDialog(finestra, "Nuovo", FileDialog.LOAD);
        dialogo.show();
        nomeDelFile = dialogo.getDirectory();
        nomeDelFile += dialogo.getFile();
        String str = area.getText();
        PrintWriter out = new PrintWriter(new FileOutputStream(nomeDelFile));
        for (int i = 0; i < str.length(); i++)
          if (str.charAt(i) == '\n')
            out.println();
          else
            out.print(str.charAt(i));
        out.close();
        } catch (IOException e) {
          finestra.errori.add("Errore di I/O");
          }
      }
    else if (comando.equals("azzera")) {
      area.setText("");
      }    
    }                              
  }

